package gregapi;

import static gregapi.data.CS.U;
import gregapi.block.prefixblock.PrefixBlockFallingEntity;
import gregapi.code.ArrayListNoNulls;
import gregapi.data.CS.ModNames;
import gregapi.data.LH;
import gregapi.data.MT;
import gregapi.data.TD;
import gregapi.item.IItemGT;
import gregapi.lang.LanguageHandler;
import gregapi.oredict.IOreDictListenerItem;
import gregapi.oredict.OreDictItemData;
import gregapi.oredict.OreDictMaterial;
import gregapi.oredict.OreDictMaterialStack;
import gregapi.render.ITexture;
import gregapi.render.RendererBlockTextured;
import gregapi.util.OM;
import gregapi.util.UT;

import java.util.Arrays;
import java.util.List;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.entity.RenderFallingBlock;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import cpw.mods.fml.client.FMLClientHandler;
import cpw.mods.fml.client.registry.RenderingRegistry;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.gameevent.TickEvent.ClientTickEvent;
import cpw.mods.fml.common.gameevent.TickEvent.Phase;

/**
 * @author Gregorius Techneticies
 */
public class GT_API_Proxy_Client extends GT_API_Proxy {
	public GT_API_Proxy_Client() {
		super();
		for (int i = 0; i < 4; i++) {
			mPosR.addAll(Arrays.asList(MT.ChargedCertusQuartz.mRGBa[i], MT.Enderium.mRGBa[i], MT.Vinteum.mRGBa[i], MT.U_235.mRGBa[i], MT.InfusedGold.mRGBa[i], MT.Am_241.mRGBa[i], MT.Pu_241.mRGBa[i], MT.Pu_243.mRGBa[i], MT.Nq_528.mRGBa[i], MT.Nq_522.mRGBa[i], MT.InfusedOrder.mRGBa[i], MT.Force.mRGBa[i], MT.Pyrotheum.mRGBa[i], MT.Sunnarium.mRGBa[i], MT.Glowstone.mRGBa[i], MT.Thaumium.mRGBa[i], MT.InfusedVis.mRGBa[i], MT.InfusedAir.mRGBa[i], MT.InfusedFire.mRGBa[i], MT.FierySteel.mRGBa[i], MT.Firestone.mRGBa[i]));
			mPosG.addAll(Arrays.asList(MT.ChargedCertusQuartz.mRGBa[i], MT.Enderium.mRGBa[i], MT.Vinteum.mRGBa[i], MT.U_235.mRGBa[i], MT.InfusedGold.mRGBa[i], MT.Am_241.mRGBa[i], MT.Pu_241.mRGBa[i], MT.Pu_243.mRGBa[i], MT.Nq_528.mRGBa[i], MT.Nq_522.mRGBa[i], MT.InfusedOrder.mRGBa[i], MT.Force.mRGBa[i], MT.Pyrotheum.mRGBa[i], MT.Sunnarium.mRGBa[i], MT.Glowstone.mRGBa[i], MT.InfusedAir.mRGBa[i], MT.InfusedEarth.mRGBa[i]));
			mPosB.addAll(Arrays.asList(MT.ChargedCertusQuartz.mRGBa[i], MT.Enderium.mRGBa[i], MT.Vinteum.mRGBa[i], MT.U_235.mRGBa[i], MT.InfusedGold.mRGBa[i], MT.Am_241.mRGBa[i], MT.Pu_241.mRGBa[i], MT.Pu_243.mRGBa[i], MT.Nq_528.mRGBa[i], MT.Nq_522.mRGBa[i], MT.InfusedOrder.mRGBa[i], MT.InfusedVis.mRGBa[i], MT.InfusedWater.mRGBa[i], MT.Thaumium.mRGBa[i], MT.Co_60.mRGBa[i], MT.Lumium.mRGBa[i]));
			mNegR.addAll(Arrays.asList(MT.InfusedEntropy.mRGBa[i], MT.NetherStar.mRGBa[i]));
			mNegG.addAll(Arrays.asList(MT.InfusedEntropy.mRGBa[i], MT.NetherStar.mRGBa[i]));
			mNegB.addAll(Arrays.asList(MT.InfusedEntropy.mRGBa[i], MT.NetherStar.mRGBa[i]));
		}
	}
	
	@Override
	public void onPreLoad() {
		RenderingRegistry.registerEntityRenderingHandler(PrefixBlockFallingEntity.class, new RenderFallingBlock());
		RenderingRegistry.registerBlockHandler(new RendererBlockTextured(RenderingRegistry.getNextAvailableRenderId()));
    	// Check if OptiFine is loaded in order to disable some GT Render Hooks to fix Glitches.
    	ITexture.Util.OPTIFINE_LOADED = FMLClientHandler.instance().hasOptifine();
	}
	
	@Override
	public void onLoad() {
		for (OreDictMaterial tMaterial : OreDictMaterial.MATERIAL_MAP.values()) LanguageHandler.add("gt.material." + tMaterial.mNameInternal, tMaterial.mNameLocal);
	}
	
	@Override
	public void onPostLoad() {
		//
	}
	
	@Override public EntityPlayer getThePlayer() {return Minecraft.getMinecraft().thePlayer;}
	@Override public boolean isServerSide() {return true;}
	@Override public boolean isClientSide() {return true;}
	
	public final List<short[]> mPosR = new ArrayListNoNulls<short[]>(), mPosG = new ArrayListNoNulls<short[]>(), mPosB = new ArrayListNoNulls<short[]>(), mPosA = new ArrayListNoNulls<short[]>(), mNegR = new ArrayListNoNulls<short[]>(), mNegG = new ArrayListNoNulls<short[]>(), mNegB = new ArrayListNoNulls<short[]>(), mNegA = new ArrayListNoNulls<short[]>();
	private long mAnimationTick = 0;
	private boolean mAnimationDirection = true;
	
	@SubscribeEvent
    public void onItemTooltip(ItemTooltipEvent aEvent) {
		if (!GT_API.sAPIPhaseFinishedPostLoad) return;
		OreDictItemData tData = OM.anydata(aEvent.itemStack);
		if (tData != null) {
			if (tData.mPrefix != null) {
				for (IOreDictListenerItem tListener : tData.mPrefix.mListenersItem) {
					String tToolTip = tListener.getListenerToolTip(aEvent.itemStack);
					if (tToolTip != null) aEvent.toolTip.add(tToolTip);
				}
			}
			for (OreDictMaterialStack tMaterial : tData.getAllMaterialStacks()) {
				for (IOreDictListenerItem tListener : tMaterial.mMaterial.mListenersItem) {
					String tToolTip = tListener.getListenerToolTip(aEvent.itemStack);
					if (tToolTip != null) aEvent.toolTip.add(tToolTip);
				}
			}
			if (tData.mPrefix != null && tData.mMaterial != null) {
				if (tData.mMaterial.mMaterial.contains(TD.Properties.HAS_TOOL_STATS)) {
					aEvent.toolTip.add(LH.Chat.BLUE + "Q: " + tData.mMaterial.mMaterial.mToolQuality + " - S: " + tData.mMaterial.mMaterial.mToolSpeed + " - D: " + tData.mMaterial.mMaterial.mToolDurability);
				}
				if (tData.mMaterial.mMaterial.mEnchantmentTools != null || tData.mMaterial.mMaterial.mEnchantmentArmors != null) {
					aEvent.toolTip.add(LH.Chat.PURPLE + "Possible Enchantments:");
					if (tData.mMaterial.mMaterial.mEnchantmentTools != null) {
						aEvent.toolTip.add(LH.Chat.PINK + tData.mMaterial.mMaterial.mEnchantmentTools.getTranslatedName(tData.mMaterial.mMaterial.mEnchantmentToolsLevel));
						if (tData.mMaterial.mMaterial.mEnchantmentTools == Enchantment.fortune		) aEvent.toolTip.add(LH.Chat.PINK + Enchantment.looting	.getTranslatedName(tData.mMaterial.mMaterial.mEnchantmentToolsLevel)); else
						if (tData.mMaterial.mMaterial.mEnchantmentTools == Enchantment.knockback	) aEvent.toolTip.add(LH.Chat.PINK + Enchantment.punch	.getTranslatedName(tData.mMaterial.mMaterial.mEnchantmentToolsLevel)); else
						if (tData.mMaterial.mMaterial.mEnchantmentTools == Enchantment.fireAspect	) aEvent.toolTip.add(LH.Chat.PINK + Enchantment.flame	.getTranslatedName(tData.mMaterial.mMaterial.mEnchantmentToolsLevel));
					}
					if (tData.mMaterial.mMaterial.mEnchantmentArmors != null && tData.mMaterial.mMaterial.mEnchantmentArmors != tData.mMaterial.mMaterial.mEnchantmentTools) {
						aEvent.toolTip.add(LH.Chat.PINK + tData.mMaterial.mMaterial.mEnchantmentArmors.getTranslatedName(tData.mMaterial.mMaterial.mEnchantmentArmorsLevel));
					}
				}
				if (tData.mMaterial.mMaterial.contains(TD.Properties.FLAMMABLE)) {
					if (tData.mMaterial.mMaterial.contains(TD.Properties.EXPLOSIVE)) {
						aEvent.toolTip.add(LH.Chat.RED + "Flammable and Explosive!");
					} else {
						aEvent.toolTip.add(LH.Chat.RED + "Flammable!");
					}
				} else if (tData.mMaterial.mMaterial.contains(TD.Properties.EXPLOSIVE)) {
					aEvent.toolTip.add(LH.Chat.RED + "Explosive!");
				}
				if (aEvent.itemStack.getItem() instanceof IItemGT) {
					if (UT.Code.stringValid(tData.mMaterial.mMaterial.mOriginalMod)) {
						if (tData.mMaterial.mMaterial.mOriginalMod.equals(ModNames.MC)) {
							aEvent.toolTip.add(LH.Chat.BLUE + "Mod: None (Vanilla Material)");
						} else {
							aEvent.toolTip.add(LH.Chat.BLUE + "Mod: " + tData.mMaterial.mMaterial.mOriginalMod);
						}
					} else {
						aEvent.toolTip.add(LH.Chat.BLUE + "Mod: Unknown (But definetly not GregTech)");
					}
				}
			}
			if (aEvent.showAdvancedItemTooltips) {
				for (OreDictMaterialStack tMaterial : tData.getAllMaterialStacks()) if (!tMaterial.mMaterial.contains(TD.Properties.DONT_SHOW_THIS_COMPONENT)) {
					if (tMaterial.mAmount > 0) {
						aEvent.toolTip.add("Contains " + (tMaterial.mAmount / U) + "." + ((int)(((double)(tMaterial.mAmount % U) / (double)U) * 1000)) + " Units of " + tMaterial.mMaterial.getLocal());
					} else if (tMaterial.mAmount < 0) {
						aEvent.toolTip.add("Contains an unknown Amount of " + tMaterial.mMaterial.getLocal());
					}
					double tWeight = tMaterial.mAmount > 0 ? tMaterial.mMaterial.getWeight(tMaterial.mAmount) : 0;
					aEvent.toolTip.add("Melt: " + tMaterial.mMaterial.mMeltingPoint + " K - Boil: " + tMaterial.mMaterial.mBoilingPoint + " K"+(tWeight>0?" - Weight: " + (long)tWeight + "." + (((long)(tWeight*1000))%1000) + " kg":""));
				}
			}
		}
    }
    
	@SubscribeEvent
	public void onClientTickEvent(ClientTickEvent aEvent) {
		if (aEvent.phase == Phase.END) {
	    	mAnimationTick++;
			if (mAnimationTick%50 == 0) mAnimationDirection = !mAnimationDirection;
			
			int tDirection = mAnimationDirection?+1:-1;
			for (short[] tArray : mPosR) {tArray[0]+=tDirection; tArray[0] = UT.Code.bindByte(tArray[0]);}
			for (short[] tArray : mPosG) {tArray[1]+=tDirection; tArray[1] = UT.Code.bindByte(tArray[1]);}
			for (short[] tArray : mPosB) {tArray[2]+=tDirection; tArray[2] = UT.Code.bindByte(tArray[2]);}
			for (short[] tArray : mPosA) {tArray[3]+=tDirection; tArray[3] = UT.Code.bindByte(tArray[3]);}
			for (short[] tArray : mNegR) {tArray[0]-=tDirection; tArray[0] = UT.Code.bindByte(tArray[0]);}
			for (short[] tArray : mNegG) {tArray[1]-=tDirection; tArray[1] = UT.Code.bindByte(tArray[1]);}
			for (short[] tArray : mNegB) {tArray[2]-=tDirection; tArray[2] = UT.Code.bindByte(tArray[2]);}
			for (short[] tArray : mNegA) {tArray[3]-=tDirection; tArray[3] = UT.Code.bindByte(tArray[3]);}
		}
	}
}