package gregapi.recipes;

import static gregapi.data.CS.*;
import static gregapi.data.OP.oreNormal;
import static gregapi.data.OP.orePoor;
import static gregapi.data.OP.oreRich;
import static gregapi.data.OP.oreSmall;
import gregapi.GT_API;
import gregapi.code.ArrayListNoNulls;
import gregapi.code.FluidStackContainer;
import gregapi.code.ItemStackContainer;
import gregapi.code.ItemStackMap;
import gregapi.config.Config;
import gregapi.config.ConfigCategories;
import gregapi.data.CS.ConfigsGT;
import gregapi.data.CS.DirectoriesGT;
import gregapi.data.*;
import gregapi.lang.LanguageHandler;
import gregapi.log.GT_Log;
import gregapi.old.Dyes;
import gregapi.old.interfaces.tileentity.IGregTechTileEntity;
import gregapi.oredict.OreDictItemData;
import gregapi.oredict.OreDictManager;
import gregapi.oredict.OreDictMaterial;
import gregapi.oredict.OreDictMaterialStack;
import gregapi.random.IHasWorldAndCoords;
import gregapi.util.OM;
import gregapi.util.UT;
import gregapi.util.UT.Fluids;

import java.util.*;

import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntityFurnace;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.IFluidContainerItem;

/**
 * NEVER INCLUDE THIS FILE IN YOUR MOD!!!
 * 
 * This File contains the functions used for Recipes. Please do not include this File AT ALL in your Moddownload as it ruins compatibility
 * This is just the Core of my Recipe System, if you just want to GET the Recipes I add, then you can access this File.
 * Do NOT add Recipes using the Constructors inside this Class, The GregTech_API File calls the correct Functions for these Constructors.
 * 
 * I know this File causes some Errors, because of missing Main Functions, but if you just need to compile Stuff, then remove said erroreous Functions.
 */
public class Recipe {
	public static class RecipeMap implements Runnable {
		/** RecipeMap-HashMap so that Machines can store their corresponding Recipe Lists as String NBT. */
		public static final Map<String, RecipeMap> RECIPE_MAPS = new HashMap<String, Recipe.RecipeMap>();
		
		public static final RecipeMap		sOreWasherRecipes							= new RecipeMapOreWasher			(new HashSet<Recipe>(    0), "ic.recipe.orewasher"					, "Ore Washer"						, "ic2.blockOreWashingPlant"	, 0, 1, RES_PATH_GUI+"machines/OreWasher"						,/*IN-OUT-MIN-ITEM=*/ 1, 3, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F, F);
		public static final RecipeMap		sThermalCentrifugeRecipes					= new RecipeMapThermalCentrifuge	(new HashSet<Recipe>(    0), "ic.recipe.thermalcentrifuge"			, "Thermal Centrifuge"				, "ic2.blockCentrifuge"			, 0, 1, RES_PATH_GUI+"machines/ThermalCentrifuge"				,/*IN-OUT-MIN-ITEM=*/ 1, 3, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 2, ""					,    1, ""		, T, F, F);
		public static final RecipeMap		sMaceratorRecipes							= new RecipeMapMacerator			(new HashSet<Recipe>(    0), "ic.recipe.macerator"					, "Macerator"						, "ic2.macerator"				, 0, 1, RES_PATH_GUI+"machines/Macerator"						,/*IN-OUT-MIN-ITEM=*/ 1, 4, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, F);
		public static final RecipeMap		sCompressorRecipes							= new RecipeMapCompressor			(new HashSet<Recipe>(    0), "ic.recipe.compressor"					, "Compressor"						, "ic2.compressor"				, 0, 1, RES_PATH_GUI+"machines/Compressor"						,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, F);
		public static final RecipeMap		sExtractorRecipes							= new RecipeMapExtractor			(new HashSet<Recipe>(    0), "ic.recipe.extractor"					, "Extractor"						, "ic2.extractor"				, 0, 1, RES_PATH_GUI+"machines/Extractor"						,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, F);
		public static final RecipeMap		sRecyclerRecipes							= new RecipeMapRecycler				(new HashSet<Recipe>(    0), "ic.recipe.recycler"					, "Recycler"						, "ic2.recycler"				, 0, 1, RES_PATH_GUI+"machines/Recycler"						,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, F);
		public static final RecipeMap		sFurnaceRecipes								= new RecipeMapFurnace				(new HashSet<Recipe>(    0), "mc.recipe.furnace"					, "Furnace"							, "smelting"					, 0, 1, RES_PATH_GUI+"machines/E_Furnace"						,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, F);
		public static final RecipeMap		sMicrowaveRecipes							= new RecipeMapMicrowave			(new HashSet<Recipe>(    0), "gt.recipe.microwave"					, "Microwave"						, "smelting"					, 0, 1, RES_PATH_GUI+"machines/E_Furnace"						,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, F);
		public static final RecipeMap		sFurnaceFuel								= new RecipeMapFurnaceFuel			(new HashSet<Recipe>(    0), "mc.recipe.furnacefuel"				, "Furnace Fuels"					, "smelting"					, 0, 1, RES_PATH_GUI+"machines/E_Furnace"						,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, F);
		
		public static final RecipeMap		sScannerFakeRecipes							= new RecipeMap						(new HashSet<Recipe>(    3), "gt.recipe.scanner"					, "Scanner"							, null							, 0, 1, RES_PATH_GUI+"machines/Scanner"							,/*IN-OUT-MIN-ITEM=*/ 2, 2, 1,/*IN-OUT-MIN-FLUID=*/ 1, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sRockBreakerFakeRecipes						= new RecipeMap						(new HashSet<Recipe>(    3), "gt.recipe.rockbreaker"				, "Rock Breaker"					, null							, 0, 1, RES_PATH_GUI+"machines/RockBreaker"						,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sByProductList								= new RecipeMap						(new HashSet<Recipe>( 1000), "gt.recipe.byproductlist"				, "Ore Byproduct List"				, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 1, 6, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, F);
		public static final RecipeMap		sCrucibleSmelting							= new RecipeMap						(new HashSet<Recipe>( 5000), "gt.recipe.cruciblesmelting"			, "Crucible Smelting"				, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 6, 6, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Temperature: "		,    1, " K"	, T, T, F);
		public static final RecipeMap		sCrucibleAlloying							= new RecipeMap						(new HashSet<Recipe>( 1000), "gt.recipe.cruciblealloying"			, "Combination Smelting"			, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 6, 6, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Temperature: "		,    1, " K"	, T, T, F);
		
		public static final RecipeMap		sSharpeningRecipes							= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.sharpener"					, "Sharpener"						, null							, 0, 1, RES_PATH_GUI+"machines/Sharpener"						,/*IN-OUT-MIN-ITEM=*/ 1, 2, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T);
		public static final RecipeMap		sSifterRecipes								= new RecipeMap						(new HashSet<Recipe>( 2000), "gt.recipe.sifter"						, "Sifter"							, null							, 2, 1, RES_PATH_GUI+"machines/Sifter"							,/*IN-OUT-MIN-ITEM=*/ 1,12, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T);
		public static final RecipeMap		sHammerRecipes								= new RecipeMapHammer				(new HashSet<Recipe>(  100), "gt.recipe.hammer"						, "Hammer"							, null							, 6, 3, RES_PATH_GUI+"machines/Hammer"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, T);
		public static final RecipeMap		sChiselRecipes								= new RecipeMapChisel				(new HashSet<Recipe>(  200), "gt.recipe.chisel"						, "Chisel"							, null							, 0, 1, RES_PATH_GUI+"machines/Chisel"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F, T);
		public static final RecipeMap		sShredderRecipes							= new RecipeMapShredder				(new HashSet<Recipe>(  100), "gt.recipe.shredder"					, "Shredder"						, null							, 0, 1, RES_PATH_GUI+"machines/Shredder"						,/*IN-OUT-MIN-ITEM=*/ 1, 4, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T);
		public static final RecipeMap		sCrusherRecipes								= new RecipeMapCrusher				(new HashSet<Recipe>(  100), "gt.recipe.crusher"					, "Crusher"							, null							, 0, 1, RES_PATH_GUI+"machines/Crusher"							,/*IN-OUT-MIN-ITEM=*/ 1, 4, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T);
		public static final RecipeMap		sLatheRecipes								= new RecipeMap						(new HashSet<Recipe>(  400), "gt.recipe.lathe"						, "Lathe"							, null							, 0, 1, RES_PATH_GUI+"machines/Lathe"							,/*IN-OUT-MIN-ITEM=*/ 1, 2, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, T, T);
		
		public static final RecipeMap		sCutterRecipes								= new RecipeMap						(new HashSet<Recipe>(  200), "gt.recipe.cuttingsaw"					, "Cutting Saw"						, null							, 0, 1, RES_PATH_GUI+"machines/Cutter"							,/*IN-OUT-MIN-ITEM=*/ 1, 2, 1,/*IN-OUT-MIN-FLUID=*/ 1, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sCannerRecipes								= new RecipeMapFluidCanner			(new HashSet<Recipe>(  300), "gt.recipe.canner"						, "Canning Machine"					, null							, 0, 1, RES_PATH_GUI+"machines/Canner"							,/*IN-OUT-MIN-ITEM=*/ 2, 2, 1,/*IN-OUT-MIN-FLUID=*/ 1, 1, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sPlasmaArcFurnaceRecipes					= new RecipeMap						(new HashSet<Recipe>(10000), "gt.recipe.plasmaarcfurnace"			, "Plasma Arc Furnace"				, null							, 0, 1, RES_PATH_GUI+"machines/PlasmaArcFurnace"				,/*IN-OUT-MIN-ITEM=*/ 1, 4, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sArcFurnaceRecipes							= new RecipeMap						(new HashSet<Recipe>(10000), "gt.recipe.arcfurnace"					, "Arc Furnace"						, null							, 0, 1, RES_PATH_GUI+"machines/ArcFurnace"						,/*IN-OUT-MIN-ITEM=*/ 1, 4, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*AMP=*/ 3, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sPrinterRecipes								= new RecipeMapPrinter				(new HashSet<Recipe>(  100), "gt.recipe.printer"					, "Printer"							, null							, 0, 1, RES_PATH_GUI+"machines/Printer"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sPressRecipes								= new RecipeMapFormingPress			(new HashSet<Recipe>(  100), "gt.recipe.press"						, "Forming Press"					, null							, 0, 1, RES_PATH_GUI+"machines/Press"							,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sLaserEngraverRecipes						= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.laserengraver"				, "Precision Laser Engraver"		, null							, 0, 1, RES_PATH_GUI+"machines/LaserEngraver"					,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sMixerRecipes								= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.mixer"						, "Mixer"							, null							, 0, 1, RES_PATH_GUI+"machines/Mixer"							,/*IN-OUT-MIN-ITEM=*/ 4, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sAutoclaveRecipes							= new RecipeMap						(new HashSet<Recipe>(  200), "gt.recipe.autoclave"					, "Autoclave"						, null							, 0, 1, RES_PATH_GUI+"machines/Autoclave"						,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sElectroMagneticSeparatorRecipes			= new RecipeMap						(new HashSet<Recipe>(   50), "gt.recipe.electromagneticseparator"	, "Electromagnetic Separator"		, null							, 0, 1, RES_PATH_GUI+"machines/ElectromagneticSeparator"		,/*IN-OUT-MIN-ITEM=*/ 1, 3, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sPolarizerRecipes							= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.polarizer"					, "Electromagnetic Polarizer"		, null							, 0, 1, RES_PATH_GUI+"machines/Polarizer"						,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sChemicalBathRecipes						= new RecipeMap						(new HashSet<Recipe>(  200), "gt.recipe.chemicalbath"				, "Chemical Bath"					, null							, 0, 1, RES_PATH_GUI+"machines/ChemicalBath"					,/*IN-OUT-MIN-ITEM=*/ 1, 3, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sBrewingRecipes								= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.brewer"						, "Brewing Machine"					, null							, 0, 1, RES_PATH_GUI+"machines/PotionBrewer"					,/*IN-OUT-MIN-ITEM=*/ 1, 0, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sFluidHeaterRecipes							= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.fluidheater"				, "Fluid Heater"					, null							, 0, 1, RES_PATH_GUI+"machines/FluidHeater"						,/*IN-OUT-MIN-ITEM=*/ 1, 0, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sDistilleryRecipes							= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.distillery"					, "Distillery"						, null							, 0, 1, RES_PATH_GUI+"machines/Distillery"						,/*IN-OUT-MIN-ITEM=*/ 1, 0, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sFermentingRecipes							= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.fermenter"					, "Fermenter"						, null							, 0, 1, RES_PATH_GUI+"machines/Fermenter"						,/*IN-OUT-MIN-ITEM=*/ 0, 0, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sFluidSolidficationRecipes					= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.fluidsolidifier"			, "Fluid Solidifier"				, null							, 0, 1, RES_PATH_GUI+"machines/FluidSolidifier"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sFluidExtractionRecipes						= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.fluidextractor"				, "Fluid Extractor"					, null							, 0, 1, RES_PATH_GUI+"machines/FluidExtractor"					,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 1, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sBoxinatorRecipes							= new RecipeMap						(new HashSet<Recipe>( 2500), "gt.recipe.packager"					, "Packager"						, null							, 0, 1, RES_PATH_GUI+"machines/Packager"						,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sUnboxinatorRecipes							= new RecipeMapUnboxinator			(new HashSet<Recipe>( 2500), "gt.recipe.unpackager"					, "Unpackager"						, null							, 0, 1, RES_PATH_GUI+"machines/Unpackager"						,/*IN-OUT-MIN-ITEM=*/ 1, 2, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sFusionRecipes								= new RecipeMap						(new HashSet<Recipe>(   50), "gt.recipe.fusionreactor"				, "Fusion Reactor"					, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 2, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Start: "				,    1, " EU"	, T, F/*F*/, F/*T*/);
		public static final RecipeMap		sCentrifugeRecipes							= new RecipeMap						(new HashSet<Recipe>( 1000), "gt.recipe.centrifuge"					, "Centrifuge"						, null							, 0, 1, RES_PATH_GUI+"machines/Centrifuge"						,/*IN-OUT-MIN-ITEM=*/ 1, 6, 0,/*IN-OUT-MIN-FLUID=*/ 1, 6, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sElectrolyzerRecipes						= new RecipeMap						(new HashSet<Recipe>(  200), "gt.recipe.electrolyzer"				, "Electrolyzer"					, null							, 0, 1, RES_PATH_GUI+"machines/Electrolyzer"					,/*IN-OUT-MIN-ITEM=*/ 2, 6, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sBlastRecipes								= new RecipeMap						(new HashSet<Recipe>(  500), "gt.recipe.blastfurnace"				, "Blast Furnace"					, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 2, 2, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Heat Capacity: "		,    1, " K"	, F, F/*T*/, F/*T*/);
		public static final RecipeMap		sImplosionRecipes							= new RecipeMap						(new HashSet<Recipe>(   50), "gt.recipe.implosioncompressor"		, "Implosion Compressor"			, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 2, 2, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sVacuumRecipes								= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.vacuumfreezer"				, "Vacuum Freezer"					, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sChemicalRecipes							= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.chemicalreactor"			, "Chemical Reactor"				, null							, 0, 1, RES_PATH_GUI+"machines/ChemicalReactor"					,/*IN-OUT-MIN-ITEM=*/ 2, 1, 1,/*IN-OUT-MIN-FLUID=*/ 1, 1, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sDistillationRecipes						= new RecipeMap						(new HashSet<Recipe>(   50), "gt.recipe.distillationtower"			, "Distillation Tower"				, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 2, 4, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*F*/, F/*T*/);
		public static final RecipeMap		sWiremillRecipes							= new RecipeMap						(new HashSet<Recipe>(   50), "gt.recipe.wiremill"					, "Wiremill"						, null							, 0, 1, RES_PATH_GUI+"machines/Wiremill"						,/*IN-OUT-MIN-ITEM=*/ 1, 1, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sBenderRecipes								= new RecipeMap						(new HashSet<Recipe>(  400), "gt.recipe.metalbender"				, "Metal Bender"					, null							, 0, 1, RES_PATH_GUI+"machines/Bender"							,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sAlloySmelterRecipes						= new RecipeMap						(new HashSet<Recipe>( 3000), "gt.recipe.alloysmelter"				, "Alloy Smelter"					, null							, 0, 1, RES_PATH_GUI+"machines/AlloySmelter"					,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sAssemblerRecipes							= new RecipeMapAssembler			(new HashSet<Recipe>(  300), "gt.recipe.assembler"					, "Assembler"						, null							, 0, 1, RES_PATH_GUI+"machines/Assembler"						,/*IN-OUT-MIN-ITEM=*/ 2, 1, 1,/*IN-OUT-MIN-FLUID=*/ 1, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sCNCRecipes									= new RecipeMap						(new HashSet<Recipe>(  100), "gt.recipe.cncmachine"					, "CNC Machine"						, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 1, 0, 1,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sSlicerRecipes								= new RecipeMap						(new HashSet<Recipe>(  200), "gt.recipe.slicer"						, "Slicer"							, null							, 0, 1, RES_PATH_GUI+"machines/Slicer"							,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sExtruderRecipes							= new RecipeMap						(new HashSet<Recipe>( 1000), "gt.recipe.extruder"					, "Extruder"						, null							, 0, 1, RES_PATH_GUI+"machines/Extruder"						,/*IN-OUT-MIN-ITEM=*/ 2, 1, 2,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMap		sAmplifiers									= new RecipeMap						(new HashSet<Recipe>(   10), "gt.recipe.uuamplifier"				, "UU Amplifier"					, null							, 0, 1, RES_PATH_GUI+"machines/Amplifabricator"					,/*IN-OUT-MIN-ITEM=*/ 1, 0, 1,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, ""					,    1, ""		, T, F/*T*/, F/*T*/);
		public static final RecipeMapFuel	sDieselFuels								= new RecipeMapFuel					(new HashSet<Recipe>(   10), "gt.recipe.dieselgeneratorfuel"		, "Diesel Generator Fuel"			, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Fuel Value: "		, 1000, " EU"	, T, F/*T*/, F/*T*/);
		public static final RecipeMapFuel	sTurbineFuels								= new RecipeMapFuel					(new HashSet<Recipe>(   10), "gt.recipe.gasturbinefuel"				, "Gas Turbine Fuel"				, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Fuel Value: "		, 1000, " EU"	, T, F/*T*/, F/*T*/);
		public static final RecipeMapFuel	sHotFuels									= new RecipeMapFuel					(new HashSet<Recipe>(   10), "gt.recipe.thermalgeneratorfuel"		, "Thermal Generator Fuel"			, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Fuel Value: "		, 1000, " EU"	, T, F/*F*/, F/*T*/);
		public static final RecipeMapFuel	sDenseLiquidFuels							= new RecipeMapFuel					(new HashSet<Recipe>(   10), "gt.recipe.semifluidboilerfuels"		, "Semifluid Boiler Fuels"			, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Fuel Value: "		, 1000, " EU"	, T, F/*T*/, F/*T*/);
		public static final RecipeMapFuel	sPlasmaFuels								= new RecipeMapFuel					(new HashSet<Recipe>(   10), "gt.recipe.plasmageneratorfuels"		, "Plasma generator Fuels"			, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Fuel Value: "		, 1000, " EU"	, T, F/*F*/, F/*T*/);
		public static final RecipeMapFuel	sMagicFuels									= new RecipeMapFuel					(new HashSet<Recipe>(   10), "gt.recipe.magicfuels"					, "Magic Fuels"						, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Fuel Value: "		, 1000, " EU"	, T, F/*F*/, F/*T*/);
		public static final RecipeMapFuel	sSmallNaquadahReactorFuels					= new RecipeMapFuel					(new HashSet<Recipe>(   10), "gt.recipe.smallnaquadahreactor"		, "Small Naquadah Reactor"			, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Fuel Value: "		, 1000, " EU"	, T, F/*T*/, F/*T*/);
		public static final RecipeMapFuel	sLargeNaquadahReactorFuels					= new RecipeMapFuel					(new HashSet<Recipe>(   10), "gt.recipe.largenaquadahreactor"		, "Large Naquadah Reactor"			, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Fuel Value: "		, 1000, " EU"	, T, F/*T*/, F/*T*/);
		public static final RecipeMapFuel	sFluidNaquadahReactorFuels					= new RecipeMapFuel					(new HashSet<Recipe>(   10), "gt.recipe.fluidnaquadahreactor"		, "Fluid Naquadah Reactor"			, null							, 0, 1, RES_PATH_GUI+"machines/Default"							,/*IN-OUT-MIN-ITEM=*/ 1, 1, 0,/*IN-OUT-MIN-FLUID=*/ 0, 0, 0,/*AMP=*/ 1, "Fuel Value: "		, 1000, " EU"	, T, F/*T*/, F/*T*/);
		
		/** HashMap of Recipes based on their Items */
		public final Map<ItemStackContainer, Collection<Recipe>> mRecipeItemMap = new ItemStackMap<ItemStackContainer, Collection<Recipe>>();
		/** HashMap of Recipes based on their Fluids */
		public final Map<Fluid, Collection<Recipe>> mRecipeFluidMap = new HashMap<Fluid, Collection<Recipe>>();
		/** The List of all Recipes */
		public final Collection<Recipe> mRecipeList;
		/** String used as an unlocalised Name. */
		public final String mNameInternal;
		/** String used as a localised Name in things that shouldn't be localised, like Config File Names. */
		public final String mNameLocal, mNameLocalUnderscored;
		/** String used in NEI for the Recipe Lists. If null it will use the unlocalised Name instead*/
		public final String mNameNEI;
		/** GUI used for NEI Display. Usually the GUI of the Machine itself */
		public final String mGUIPath;
		public final String mNEISpecialValuePre, mNEISpecialValuePost;
		public final byte mProgressBarDirection, mProgressBarAmount;
		public final int mInputItemsCount, mOutputItemsCount, mInputFluidCount, mOutputFluidCount, mMinimalInputItems, mMinimalInputFluids;
		public final long mNEISpecialValueMultiplier, mPower;
		public final boolean mNEIAllowed, mShowVoltageAmperageInNEI;
		/** Used to determine Input Tank Size. Contains the size of the largest FluidStack Input. */
		public int mMaxFluidInputSize = 1000;
		/** The Config File corresponding to this Recipe Handler. Will be initialised by GT_API. */
		public Config mConfigFile = null;
		
		/**
		 * Initialises a new type of Recipe Handler.
		 * @param aRecipeList a List you specify as Recipe List. Usually just an ArrayList with a pre-initialised Size.
		 * @param aNameInternal the unlocalised Name of this Recipe Handler, used mainly for NEI.
		 * @param aNameLocal the displayed Name inside the NEI Recipe GUI and regular ToolTips.
		 * @param aNEIGUIPath the displayed GUI Texture, usually just a Machine GUI. Auto-Attaches ".png" if forgotten.
		 * @param aInputItemsCount the usual amount of Input Slots this Recipe Class has.
		 * @param aOutputItemsCount the usual amount of Output Slots this Recipe Class has.
		 * @param aNEISpecialValuePre the String in front of the Special Value in NEI.
		 * @param aNEISpecialValueMultiplier the Value the Special Value is getting Multiplied with before displaying
		 * @param aNEISpecialValuePost the String after the Special Value. Usually for a Unit or something.
		 * @param aNEIAllowed if NEI is allowed to display this Recipe Handler in general.
		 */
		public RecipeMap(Collection<Recipe> aRecipeList, String aNameInternal, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			mNEIAllowed = aNEIAllowed;
			mShowVoltageAmperageInNEI = aShowVoltageAmperageInNEI;
			mRecipeList = aRecipeList;
			mNameInternal = aNameInternal;
			mNameLocal = aNameLocal;
			mNameLocalUnderscored = mNameLocal.replaceAll(" ", "_");
			mNameNEI = aNameNEI == null ? mNameInternal : aNameNEI;
			mGUIPath = aNEIGUIPath.endsWith(".png")?aNEIGUIPath:aNEIGUIPath + ".png";
			mNEISpecialValuePre = aNEISpecialValuePre;
			mNEISpecialValueMultiplier = aNEISpecialValueMultiplier;
			mNEISpecialValuePost = aNEISpecialValuePost;
			mPower = aPower;
			mMinimalInputItems = (int)aMinimalInputItems;
			mInputItemsCount = (int)Math.max(aInputItemsCount, mMinimalInputItems);
			mOutputItemsCount = (int)aOutputItemsCount;
			mMinimalInputFluids = (int)aMinimalInputFluids;
			mInputFluidCount = (int)Math.max(aInputFluidCount, mMinimalInputFluids);
			mOutputFluidCount = (int)aOutputFluidCount;
			mProgressBarDirection = (byte)aProgressBarDirection;
			mProgressBarAmount = (byte)aProgressBarAmount;
			GT_API.FLUIDMAPS.add(mRecipeFluidMap);
			LanguageHandler.add(mNameInternal, mNameLocal);
			if (RECIPE_MAPS.containsKey(mNameInternal)) throw new IllegalArgumentException("Recipe Map Name already exists: " + mNameInternal);
			RECIPE_MAPS.put(mNameInternal, this);
			if (aConfigAllowed) if (GT_API.sAPIPreInitBefore != null) GT_API.sAPIPreInitBefore.add(this); else run();
		}
		
		@Override public String toString() {return "RecipeMap: " + mNameLocal;}
		@Override public void run() {mConfigFile = new Config(DirectoriesGT.CONFIG_RECIPES, mNameLocalUnderscored+".cfg");}
		
		@Deprecated
		public RecipeMap(Collection<Recipe> aRecipeList, String aNameInternal, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed) {
			this(aRecipeList, aNameInternal, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, T);
		}
		
		@Deprecated
		public RecipeMap(Collection<Recipe> aRecipeList, String aNameInternal, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed) {
			this(aRecipeList, aNameInternal, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, 0, 0, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, T);
		}
		
		@Deprecated
		public RecipeMap(Collection<Recipe> aRecipeList, String aNameInternal, String aNameLocal, String aNameNEI, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed) {
			this(aRecipeList, aNameInternal, aNameLocal, aNameNEI, 0, 1, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, 0, 0, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, T);
		}
		
		public Recipe addRecipe(boolean aOptimize, ItemStack[] aInputs, ItemStack[] aOutputs, Object aSpecial, long[] aOutputChances, FluidStack[] aFluidInputs, FluidStack[] aFluidOutputs, long aDuration, long aEUt, long aSpecialValue) {
			return addRecipe(new Recipe(aOptimize, aInputs, aOutputs, aSpecial, aOutputChances, aFluidInputs, aFluidOutputs, aDuration, aEUt, aSpecialValue));
		}
		
		public Recipe addRecipe(Recipe aRecipe) {
			return addRecipe(aRecipe, T, F, F);
		}
		
		// The Number next to the addRecipe is for the amount of Item Inputs used. X = Array
		
		public Recipe addRecipe1(boolean aOptimize, long aEUt, long aDuration, long   aChance	, ItemStack aInput																					, ItemStack    aOutput	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput}				, new ItemStack[] {aOutput}	, NI, new long[] {aChance}	, ZL_FLUIDSTACK						, ZL_FLUIDSTACK						, aDuration, aEUt, 0));}
		public Recipe addRecipe2(boolean aOptimize, long aEUt, long aDuration, long   aChance	, ItemStack aInput1, ItemStack aInput2																, ItemStack    aOutput	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput1, aInput2}	, new ItemStack[] {aOutput}	, NI, new long[] {aChance}	, ZL_FLUIDSTACK						, ZL_FLUIDSTACK						, aDuration, aEUt, 0));}
		public Recipe addRecipeX(boolean aOptimize, long aEUt, long aDuration, long   aChance	, ItemStack[] aInputs																				, ItemStack    aOutput	) {return addRecipe(new Recipe(aOptimize, aInputs								, new ItemStack[] {aOutput}	, NI, new long[] {aChance}	, ZL_FLUIDSTACK						, ZL_FLUIDSTACK						, aDuration, aEUt, 0));}
		public Recipe addRecipe1(boolean aOptimize, long aEUt, long aDuration					, ItemStack aInput																					, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput}				, aOutputs					, NI, ZL_LONG				, ZL_FLUIDSTACK						, ZL_FLUIDSTACK						, aDuration, aEUt, 0));}
		public Recipe addRecipe2(boolean aOptimize, long aEUt, long aDuration					, ItemStack aInput1, ItemStack aInput2																, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput1, aInput2}	, aOutputs					, NI, ZL_LONG				, ZL_FLUIDSTACK						, ZL_FLUIDSTACK						, aDuration, aEUt, 0));}
		public Recipe addRecipeX(boolean aOptimize, long aEUt, long aDuration					, ItemStack[] aInputs																				, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, aInputs								, aOutputs					, NI, ZL_LONG				, ZL_FLUIDSTACK						, ZL_FLUIDSTACK						, aDuration, aEUt, 0));}
		public Recipe addRecipe1(boolean aOptimize, long aEUt, long aDuration, long[] aChances	, ItemStack aInput																					, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput}				, aOutputs					, NI, aChances				, ZL_FLUIDSTACK						, ZL_FLUIDSTACK						, aDuration, aEUt, 0));}
		public Recipe addRecipe2(boolean aOptimize, long aEUt, long aDuration, long[] aChances	, ItemStack aInput1, ItemStack aInput2																, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput1, aInput2}	, aOutputs					, NI, aChances				, ZL_FLUIDSTACK						, ZL_FLUIDSTACK						, aDuration, aEUt, 0));}
		public Recipe addRecipeX(boolean aOptimize, long aEUt, long aDuration, long[] aChances	, ItemStack[] aInputs																				, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, aInputs								, aOutputs					, NI, aChances				, ZL_FLUIDSTACK						, ZL_FLUIDSTACK						, aDuration, aEUt, 0));}
		public Recipe addRecipe0(boolean aOptimize, long aEUt, long aDuration, long   aChance												, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack    aOutput	) {return addRecipe(new Recipe(aOptimize, ZL_ITEMSTACK							, new ItemStack[] {aOutput}	, NI, new long[] {aChance}	, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipe1(boolean aOptimize, long aEUt, long aDuration, long   aChance	, ItemStack aInput							, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack    aOutput	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput}				, new ItemStack[] {aOutput}	, NI, new long[] {aChance}	, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipe2(boolean aOptimize, long aEUt, long aDuration, long   aChance	, ItemStack aInput1, ItemStack aInput2		, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack    aOutput	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput1, aInput2}	, new ItemStack[] {aOutput}	, NI, new long[] {aChance}	, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipeX(boolean aOptimize, long aEUt, long aDuration, long   aChance	, ItemStack[] aInputs						, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack    aOutput	) {return addRecipe(new Recipe(aOptimize, aInputs								, new ItemStack[] {aOutput}	, NI, new long[] {aChance}	, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipe0(boolean aOptimize, long aEUt, long aDuration																, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, ZL_ITEMSTACK							, aOutputs					, NI, ZL_LONG				, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipe1(boolean aOptimize, long aEUt, long aDuration					, ItemStack aInput							, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput}				, aOutputs					, NI, ZL_LONG				, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipe2(boolean aOptimize, long aEUt, long aDuration					, ItemStack aInput1, ItemStack aInput2		, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput1, aInput2}	, aOutputs					, NI, ZL_LONG				, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipeX(boolean aOptimize, long aEUt, long aDuration					, ItemStack[] aInputs						, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, aInputs								, aOutputs					, NI, ZL_LONG				, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipe0(boolean aOptimize, long aEUt, long aDuration, long[] aChances												, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, ZL_ITEMSTACK							, aOutputs					, NI, aChances				, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipe1(boolean aOptimize, long aEUt, long aDuration, long[] aChances	, ItemStack aInput							, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput}				, aOutputs					, NI, aChances				, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipe2(boolean aOptimize, long aEUt, long aDuration, long[] aChances	, ItemStack aInput1, ItemStack aInput2		, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput1, aInput2}	, aOutputs					, NI, aChances				, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipeX(boolean aOptimize, long aEUt, long aDuration, long[] aChances	, ItemStack[] aInputs						, FluidStack aFluidInput, FluidStack    aFluidOutput	, ItemStack... aOutputs	) {return addRecipe(new Recipe(aOptimize, aInputs								, aOutputs					, NI, aChances				, new FluidStack[] {aFluidInput}	, new FluidStack[] {aFluidOutput}	, aDuration, aEUt, 0));}
		public Recipe addRecipe0(boolean aOptimize, long aEUt, long aDuration																, FluidStack aFluidInput, FluidStack... aFluidOutputs							) {return addRecipe(new Recipe(aOptimize, ZL_ITEMSTACK							, ZL_ITEMSTACK				, NI, ZL_LONG				, new FluidStack[] {aFluidInput}	, aFluidOutputs						, aDuration, aEUt, 0));}
		public Recipe addRecipe1(boolean aOptimize, long aEUt, long aDuration					, ItemStack aInput							, FluidStack aFluidInput, FluidStack... aFluidOutputs							) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput}				, ZL_ITEMSTACK				, NI, ZL_LONG				, new FluidStack[] {aFluidInput}	, aFluidOutputs						, aDuration, aEUt, 0));}
		public Recipe addRecipe2(boolean aOptimize, long aEUt, long aDuration					, ItemStack aInput1, ItemStack aInput2		, FluidStack aFluidInput, FluidStack... aFluidOutputs							) {return addRecipe(new Recipe(aOptimize, new ItemStack[] {aInput1, aInput2}	, ZL_ITEMSTACK				, NI, ZL_LONG				, new FluidStack[] {aFluidInput}	, aFluidOutputs						, aDuration, aEUt, 0));}
		public Recipe addRecipeX(boolean aOptimize, long aEUt, long aDuration					, ItemStack[] aInputs						, FluidStack aFluidInput, FluidStack... aFluidOutputs							) {return addRecipe(new Recipe(aOptimize, aInputs								, ZL_ITEMSTACK				, NI, ZL_LONG				, new FluidStack[] {aFluidInput}	, aFluidOutputs						, aDuration, aEUt, 0));}
		
		protected Recipe addRecipe(Recipe aRecipe, boolean aCheckForCollisions, boolean aFakeRecipe, boolean aHidden) {
			aRecipe.mHidden = aHidden;
			aRecipe.mFakeRecipe = aFakeRecipe;
			if (aCheckForCollisions && findRecipe(null, null, F, Long.MAX_VALUE, null, aRecipe.mFluidInputs, aRecipe.mInputs) != null) return null;
			return add(aRecipe);
		}
		
		/** Only used for fake Recipe Handlers to show something in NEI, do not use this for adding actual Recipes! findRecipe wont find fake Recipes, containsInput WILL find fake Recipes */
		public Recipe addFakeRecipe(boolean aCheckForCollisions, ItemStack[] aInputs, ItemStack[] aOutputs, Object aSpecial, long[] aOutputChances, FluidStack[] aFluidInputs, FluidStack[] aFluidOutputs, long aDuration, long aEUt, long aSpecialValue) {
			return addFakeRecipe(aCheckForCollisions, new Recipe(F, aInputs, aOutputs, aSpecial, aOutputChances, aFluidInputs, aFluidOutputs, aDuration, aEUt, aSpecialValue));
		}
		
		/** Only used for fake Recipe Handlers to show something in NEI, do not use this for adding actual Recipes! findRecipe wont find fake Recipes, containsInput WILL find fake Recipes */
		public Recipe addFakeRecipe(boolean aCheckForCollisions, ItemStack[] aInputs, ItemStack[] aOutputs, Object aSpecial, FluidStack[] aFluidInputs, FluidStack[] aFluidOutputs, long aDuration, long aEUt, long aSpecialValue) {
			return addFakeRecipe(aCheckForCollisions, new Recipe(F, aInputs, aOutputs, aSpecial, null, aFluidInputs, aFluidOutputs, aDuration, aEUt, aSpecialValue));
		}
		
		/** Only used for fake Recipe Handlers to show something in NEI, do not use this for adding actual Recipes! findRecipe wont find fake Recipes, containsInput WILL find fake Recipes */
		public Recipe addFakeRecipe(boolean aCheckForCollisions, Recipe aRecipe) {
			return addRecipe(aRecipe, aCheckForCollisions, T, F);
		}
		
		public Recipe add(Recipe aRecipe) {
			if (!aRecipe.mFakeRecipe) {
				boolean tErrored = F, tFailed = F;
				if (aRecipe.mInputs.length + aRecipe.mFluidInputs.length <= 0) {
					GT_Log.err.println("Error: Recipe has no Inputs!");
					tFailed = T;
				} else {
					if (aRecipe.mInputs			.length < mMinimalInputItems	) {GT_Log.err.println("Error: Recipe has less than the minimal amount of Input ItemStacks!"		); tFailed = T;}
					if (aRecipe.mFluidInputs	.length < mMinimalInputFluids	) {GT_Log.err.println("Error: Recipe has less than the minimal amount of Input FluidStacks!"	); tFailed = T;}
					if (aRecipe.mInputs			.length > mInputItemsCount		) {GT_Log.err.println("Error: Recipe has more than the maximum amount of Input ItemStacks!"		); tFailed = T;}
					if (aRecipe.mFluidInputs	.length > mInputFluidCount		) {GT_Log.err.println("Error: Recipe has more than the maximum amount of Input FluidStacks!"	); tFailed = T;}
				}
				if (aRecipe.mOutputs			.length > mOutputItemsCount		) {GT_Log.err.println("WARNING: Recipe has more than the maximum amount of Output ItemStacks!"	); tErrored = T;}
				if (aRecipe.mFluidOutputs		.length > mOutputFluidCount		) {GT_Log.err.println("WARNING: Recipe has more than the maximum amount of Output FluidStacks!"	); tErrored = T;}
				if (aRecipe.mEUt											== 0) {GT_Log.err.println("WARNING: Recipe has no Energy Value!"									); tErrored = T;}
				if (aRecipe.mDuration										== 0) {GT_Log.err.println("WARNING: Recipe has no Duration Value!"									); tErrored = T;}
				
				if (tErrored || tFailed) {
					int i = 0; for (StackTraceElement tElement : new Exception().getStackTrace()) if (!tElement.getClassName().equals("gregapi.recipes.Recipe$RecipeMap")) if (i++<5 && !tElement.getClassName().startsWith("sun")) GT_Log.err.println("\tat " + tElement); else break;
					if (tFailed) return null;
				}
			}
			
			if (mConfigFile != null) {
				String tConfigName = "";
				if (aRecipe.mInputs.length > 0) tConfigName += UT.Stacks.configNames(aRecipe.mInputs);
				if (aRecipe.mFluidInputs.length > 0) tConfigName += UT.Fluids.configNames(aRecipe.mFluidInputs);
				if (UT.Code.stringValid(tConfigName)) {
					aRecipe.mDuration = mConfigFile.get(mNameLocalUnderscored, tConfigName, aRecipe.mEnabled?aRecipe.mDuration:0);
					aRecipe.mEnabled = (aRecipe.mDuration > 0);
				}
			}
			
			mRecipeList.add(aRecipe);
			for (FluidStack aFluid : aRecipe.mFluidInputs) if (aFluid != null) {
				mMaxFluidInputSize = Math.max(mMaxFluidInputSize, aFluid.amount);
				Collection<Recipe> tList = mRecipeFluidMap.get(aFluid.getFluid());
				if (tList == null) mRecipeFluidMap.put(aFluid.getFluid(), tList = new HashSet<Recipe>(1));
				tList.add(aRecipe);
			}
			return addToItemMap(aRecipe);
		}
		
		public void reInit() {
        	mRecipeItemMap.clear();
        	for (Recipe tRecipe : mRecipeList) {
        		OreDictManager.INSTANCE.setStackArray(T, tRecipe.mInputs);
        		OreDictManager.INSTANCE.setStackArray(T, tRecipe.mOutputs);
            	addToItemMap(tRecipe);
        	}
		}
		
		/** @return if this Item is a valid Input for any for the Recipes */
		public boolean containsInput(ItemStack aStack) {
			return aStack != null && (mRecipeItemMap.containsKey(new ItemStackContainer(aStack)) || mRecipeItemMap.containsKey(new ItemStackContainer(UT.Stacks.copyMeta(W, aStack))));
		}
		
		/** @return if this Fluid is a valid Input for any for the Recipes */
		public boolean containsInput(FluidStack aFluid) {
			return aFluid != null && containsInput(aFluid.getFluid());
		}
		
		/** @return if this Fluid is a valid Input for any for the Recipes */
		public boolean containsInput(Fluid aFluid) {
			return aFluid != null && mRecipeFluidMap.containsKey(aFluid);
		}
		
		private Recipe oRecipe = null;
		
		/**
		 * finds a Recipe matching the aFluid and ItemStack Inputs.
		 * @param aTileEntity an Object representing the current coordinates of the executing Block/Entity/Whatever. This may be null, especially during Startup.
		 * @param aRecipe in case this is != null it will try to use this Recipe first when looking things up.
		 * @param aNotUnificated if this is T the Recipe searcher will unificate the ItemStack Inputs
		 * @param aSize Voltage of the Machine or Long.MAX_VALUE if it has no Voltage
		 * @param aFluids the Fluid Inputs
		 * @param aSpecialSlot the content of the Special Slot, the regular Manager doesn't do anything with this, but some custom ones do.
		 * @param aInputs the Item Inputs
		 * @return the Recipe it has found or null for no matching Recipe
		 */
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			// No Recipes? Well, nothing to be found then.
			if (mRecipeList.isEmpty()) return null;
			
			// Some Recipe Classes require a certain amount of Inputs of certain kinds. Like "at least 1 Fluid + 1 Stack" or "at least 2 Stacks" before they start searching for Recipes.
			// This improves Performance massively, especially if people leave things like Circuits, Molds or Shapes in their Machines to select Sub Recipes.
			if (GT_API.sAPIPhaseFinishedServerStarted) {
				if (mMinimalInputFluids > 0) {
					if (aFluids == null) return null;
					long tAmount = 0;
					for (FluidStack aFluid : aFluids) if (aFluid != null) tAmount++;
					if (tAmount < mMinimalInputFluids) return null;
				}
				if (mMinimalInputItems > 0) {
					if (aInputs == null) return null;
					long tAmount = 0;
					for (ItemStack aInput : aInputs) if (aInput != null) tAmount++;
					if (tAmount < mMinimalInputItems) return null;
				}
			}
			
			// Unification happens here in case the Input isn't already unificated.
			if (aNotUnificated) aInputs = OreDictManager.INSTANCE.getStackArray(T, (Object[])aInputs);
			
			// Check the Recipe which has been used last time in order to not have to search for it again, if possible.
			if (aRecipe != null) if (!aRecipe.mFakeRecipe && aRecipe.mCanBeBuffered && aRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return aRecipe.mEnabled&&aSize*mPower>=aRecipe.mEUt?oRecipe=aRecipe:null;
			if (oRecipe != null) if (!oRecipe.mFakeRecipe && oRecipe.mCanBeBuffered && oRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return oRecipe.mEnabled&&aSize*mPower>=oRecipe.mEUt?oRecipe:null;
			
			// Now look for the Recipes inside the Item HashMaps, but only when the Recipes usually have Items.
			if (mInputItemsCount > 0 && aInputs != null) for (ItemStack tStack1 : aInputs) if (tStack1 != null) {
				Collection<Recipe>
				tRecipes = mRecipeItemMap.get(new ItemStackContainer(tStack1));
				if (tRecipes != null) for (Recipe tRecipe : tRecipes) if (!tRecipe.mFakeRecipe && tRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return tRecipe.mEnabled&&aSize*mPower>=tRecipe.mEUt?oRecipe=tRecipe:null;
				
				tRecipes = mRecipeItemMap.get(new ItemStackContainer(UT.Stacks.copyMeta(W, tStack1)));
				if (tRecipes != null) for (Recipe tRecipe : tRecipes) if (!tRecipe.mFakeRecipe && tRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return tRecipe.mEnabled&&aSize*mPower>=tRecipe.mEUt?oRecipe=tRecipe:null;
				
				ItemStack tStack2 = OreDictManager.INSTANCE.getStack(F, tStack1);
				
				if (!UT.Stacks.equal(tStack1, tStack2, true)) {
				tRecipes = mRecipeItemMap.get(new ItemStackContainer(tStack2));
				if (tRecipes != null) for (Recipe tRecipe : tRecipes) if (!tRecipe.mFakeRecipe && tRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return tRecipe.mEnabled&&aSize*mPower>=tRecipe.mEUt?oRecipe=tRecipe:null;
				}
				if (tStack1.getItem() != tStack2.getItem()) {
				tRecipes = mRecipeItemMap.get(new ItemStackContainer(UT.Stacks.copyMeta(W, tStack2)));
				if (tRecipes != null) for (Recipe tRecipe : tRecipes) if (!tRecipe.mFakeRecipe && tRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return tRecipe.mEnabled&&aSize*mPower>=tRecipe.mEUt?oRecipe=tRecipe:null;
				}
			}
			
			// If the minimal Amount of Items for the Recipe is 0, then it could be a Fluid-Only Recipe, so check that Map too.
			if (mMinimalInputItems == 0 && aFluids != null) for (FluidStack aFluid : aFluids) if (aFluid != null) {
				Collection<Recipe>
				tRecipes = mRecipeFluidMap.get(aFluid.getFluid());
				if (tRecipes != null) for (Recipe tRecipe : tRecipes) if (!tRecipe.mFakeRecipe && tRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return tRecipe.mEnabled&&aSize*mPower>=tRecipe.mEUt?oRecipe=tRecipe:null;
			}
			
			// And nothing has been found.
			return null;
		}
		
		public List<Recipe> getNEIAllRecipes() {
			ArrayListNoNulls<Recipe> rList = new ArrayListNoNulls<Recipe>();
			for (Recipe tRecipe : mRecipeList) if (!tRecipe.mHidden) rList.add(tRecipe);
			return rList;
		}
		
		public List<Recipe> getNEIRecipes(ItemStack... aOutputs) {
			ArrayListNoNulls<Recipe> rList = new ArrayListNoNulls<Recipe>();
			for (Recipe tRecipe : mRecipeList) if (!tRecipe.mHidden) {
				for (ItemStack aOutput : aOutputs) if (aOutput != null) {
					if (IL.Display_Fluid.equal(aOutput, T, T)) {
						for (FluidStack tOutput : tRecipe.mFluidOutputs) if (IL.Display_Fluid.equal(tOutput, T, T)) {
							if (tOutput.getFluidID() == Items.feather.getDamage(aOutput)) {
								rList.add(tRecipe);
								break;
							}
						}
					} else {
						for (ItemStack tOutput : tRecipe.mOutputs) if (tOutput != null && tOutput.getItem() == aOutput.getItem()) {
							if (Items.feather.getDamage(tOutput) == W || Items.feather.getDamage(tOutput) == Items.feather.getDamage(aOutput) || tOutput.isItemStackDamageable()) {
								rList.add(tRecipe);
								break;
							}
						}
					}
				}
			}
			return rList;
		}
		
		public List<Recipe> getNEIUsages(ItemStack... aInputs) {
			ArrayListNoNulls<Recipe> rList = new ArrayListNoNulls<Recipe>();
			for (Recipe tRecipe : mRecipeList) if (!tRecipe.mHidden) {
				for (ItemStack aInput : aInputs) if (aInput != null) {
					if (IL.Display_Fluid.equal(aInput, T, T)) {
						for (FluidStack tInput : tRecipe.mFluidInputs) if (IL.Display_Fluid.equal(tInput, T, T)) {
							if (tInput.getFluidID() == Items.feather.getDamage(aInput)) {
								rList.add(tRecipe);
								break;
							}
						}
					} else {
						for (ItemStack tInput : tRecipe.mInputs) if (tInput != null && tInput.getItem() == aInput.getItem()) {
							if (Items.feather.getDamage(tInput) == W || Items.feather.getDamage(tInput) == Items.feather.getDamage(aInput) || tInput.isItemStackDamageable()) {
								rList.add(tRecipe);
								break;
							}
						}
					}
				}
			}
			return rList;
		}
		
		protected Recipe addToItemMap(Recipe aRecipe) {
			for (ItemStack aStack : aRecipe.mInputs) if (aStack != null) {
				ItemStackContainer tStack = new ItemStackContainer(aStack);
				Collection<Recipe> tList = mRecipeItemMap.get(tStack);
				if (tList == null) mRecipeItemMap.put(tStack, tList = new HashSet<Recipe>(1));
				tList.add(aRecipe);
			}
			return aRecipe;
		}
		
		public boolean openNEI() {
			try {codechicken.nei.recipe.GuiCraftingRecipe.openRecipeGui(mNameNEI, new Object[0]); return true;} catch(Throwable e) {/**/}
			return false;
		}
	}
	
	public static void reInit() {
        GT_Log.out.println("GT_API: Re-Unificating Recipes.");
        for (RecipeMap tMapEntry : RecipeMap.RECIPE_MAPS.values()) tMapEntry.reInit();
	}
	
	/** If you want to change the Output, feel free to modify or even replace the whole ItemStack Array, for Inputs, please add a new Recipe, because of the HashMaps. */
	public ItemStack[] mInputs, mOutputs;
	/** If you want to change the Output, feel free to modify or even replace the whole ItemStack Array, for Inputs, please add a new Recipe, because of the HashMaps. */
	public FluidStack[] mFluidInputs, mFluidOutputs;
	/** If you changed the amount of Array-Items inside the Output Array then the length of this Array must be larger or equal to the Output Array. A chance of 10000 equals 100% if the MaxChance Value is default. */
	public long[] mChances, mMaxChances;
	/** An Item that needs to be inside the Special Slot, like for example the Copy Slot inside the Printer. This is only useful for Fake Recipes in NEI, since findRecipe() and containsInput() don't give a shit about this Field. Lists are also possible. */
	public Object mSpecialItems;
	
	public long mDuration, mEUt, mSpecialValue;
	
	/** Use this to just disable a specific Recipe, but the Configuration enables that already for every single Recipe. */
	public boolean mEnabled = T;
	/** If this Recipe is hidden from NEI */
	public boolean mHidden = F;
	/** If this Recipe is Fake and therefore doesn't get found by the findRecipe Function (It is still in the HashMaps, so that containsInput does return T on those fake Inputs) */
	public boolean mFakeRecipe = F;
	/** If this Recipe can be stored inside a Machine in order to make Recipe searching more Efficient by trying the previously used Recipe first. In case you have a Recipe Map overriding things and returning one time use Recipes, you have to set this to F. */
	public boolean mCanBeBuffered = T;
	/** If this Recipe needs the Output Slots to be completely empty. Needed in case you have randomised Outputs */
	public boolean mNeedsEmptyOutput = F;
	
	public int getOutputChance(long aIndex) {if (aIndex < 0 || aIndex >= mChances.length) return 10000; return (int)mChances[(int)aIndex];}
	public int getMaxChance(long aIndex) {if (aIndex < 0 || aIndex >= mMaxChances.length) return 10000; return (int)mMaxChances[(int)aIndex];}
	
	public ItemStack getRepresentativeInput(long aIndex) {if (aIndex < 0 || aIndex >= mInputs.length) return null; return UT.Stacks.copy(mInputs[(int)aIndex]);}
	public ItemStack getOutput(long aIndex) {if (aIndex < 0 || aIndex >= mOutputs.length) return null; return UT.Stacks.copy(mOutputs[(int)aIndex]);}
	
	public FluidStack getRepresentativeFluidInput(long aIndex) {if (aIndex < 0 || aIndex >= mFluidInputs.length || mFluidInputs[(int)aIndex] == null) return null; return mFluidInputs[(int)aIndex].copy();}
	public FluidStack getFluidOutput(long aIndex) {if (aIndex < 0 || aIndex >= mFluidOutputs.length || mFluidOutputs[(int)aIndex] == null) return null; return mFluidOutputs[(int)aIndex].copy();}
	
	public Recipe copy() {
		return new Recipe(this);
	}
	
	public FluidStack[] getFluidOutputs(Random aRandom) {
		FluidStack[] rArray = new FluidStack[mFluidOutputs.length];
		for (int i = 0; i < rArray.length; i++) rArray[i] = getFluidOutput(i);
		return rArray;
	}
	
	public ItemStack[] getOutputs(Random aRandom) {
		ItemStack[] rArray = new ItemStack[mOutputs.length];
		if (aRandom == null) aRandom = new Random();
		for (int i = 0; i < rArray.length; i++) {
			ItemStack tOutput = getOutput(i);
			if (tOutput != null) {
				int tChance = getOutputChance(i);
				if (tChance > 0) {
					int tMax = getMaxChance(i);
					if (tChance == tMax) {
						rArray[i] = tOutput;
					} else if (tChance < tMax) {
						for (int j = 0; j < tOutput.stackSize; j++) if (aRandom.nextInt(tMax) < tChance) {
							if (rArray[i] == null) rArray[i] = UT.Stacks.copyAmount(1, tOutput); else rArray[i].stackSize++;
						}
					} else {
						int tIterations = (3*tChance) / (2*tMax), tAmount = tOutput.stackSize;
						tChance /= tIterations;
						for (int j = 0; j < tIterations; j++) if (aRandom.nextInt(tMax) < tChance) {
							if (rArray[i] == null) rArray[i] = tOutput; else rArray[i].stackSize += tAmount;
						}
					}
				} else {
					rArray[i] = tOutput;
				}
			}
		}
		return rArray;
	}
	
	public boolean isRecipeInputEqual(boolean aDecreaseStacksizeBySuccess, FluidStack[] aFluidInputs, ItemStack... aInputs) {
		return isRecipeInputEqual(aDecreaseStacksizeBySuccess, F, aFluidInputs, aInputs);
	}
	
	public boolean isRecipeInputEqual(boolean aDecreaseStacksizeBySuccess, boolean aDontCheckStackSizes, FluidStack[] aFluidInputs, ItemStack... aInputs) {
		if (mFluidInputs.length > 0 && (aFluidInputs == null || aFluidInputs.length < 1)) return F;		
		if (mInputs.length > 0 && (aInputs == null || aInputs.length < 1)) return F;
		
		for (FluidStack tFluid : mFluidInputs) if (tFluid != null) {
			boolean temp = T;
			for (FluidStack aFluid : aFluidInputs) if (aFluid != null && aFluid.isFluidEqual(tFluid) && (aDontCheckStackSizes || aFluid.amount >= tFluid.amount)) {temp = F; break;}
			if (temp) return F;
		}
		
		for (ItemStack tStack : mInputs) if (tStack != null) {boolean temp = T;
			for (ItemStack aStack : aInputs) if ((UT.Stacks.equal(OM.get(aStack), tStack, T) || UT.Stacks.equal(OreDictManager.INSTANCE.getStack(F, aStack), tStack, T)) && (aDontCheckStackSizes || aStack.stackSize >= tStack.stackSize)) {temp = F; break;}
			if (temp) return F;
		}
		
		if (aDecreaseStacksizeBySuccess) {
			if (aFluidInputs	!= null) for (FluidStack	tFluid : mFluidInputs	) if (tFluid != null) for (FluidStack	aFluid : aFluidInputs	) if (aFluid != null && aFluid.isFluidEqual(tFluid)																				&& (aDontCheckStackSizes || aFluid.amount		>= tFluid.amount	)) {aFluid.amount		-= tFluid.amount	; break;}
			if (aInputs			!= null) for (ItemStack		tStack : mInputs		) if (tStack != null) for (ItemStack	aStack : aInputs		) if ((UT.Stacks.equal(OM.get(aStack), tStack, T) || UT.Stacks.equal(OreDictManager.INSTANCE.getStack(F, aStack), tStack, T))	&& (aDontCheckStackSizes || aStack.stackSize	>= tStack.stackSize	)) {aStack.stackSize	-= tStack.stackSize	; break;}
		}
		
		return T;
	}
	
	private Recipe(Recipe aRecipe) {
		mInputs = UT.Stacks.copyArray((Object[])aRecipe.mInputs);
		mOutputs = UT.Stacks.copyArray((Object[])aRecipe.mOutputs);
		mSpecialItems = aRecipe.mSpecialItems;
		mChances = Arrays.copyOf(aRecipe.mChances, aRecipe.mChances.length);
		mMaxChances = Arrays.copyOf(aRecipe.mMaxChances, aRecipe.mMaxChances.length);
		mFluidInputs = UT.Fluids.copyArray(aRecipe.mFluidInputs);
		mFluidOutputs = UT.Fluids.copyArray(aRecipe.mFluidOutputs);
		mEUt = aRecipe.mEUt;
		mDuration = aRecipe.mDuration;
		mSpecialValue = aRecipe.mSpecialValue;
		mNeedsEmptyOutput = aRecipe.mNeedsEmptyOutput;
		mCanBeBuffered = aRecipe.mCanBeBuffered;
		mFakeRecipe = aRecipe.mFakeRecipe;
		mEnabled = aRecipe.mEnabled;
		mHidden = aRecipe.mHidden;
	}
	
	protected Recipe(boolean aOptimize, ItemStack[] aInputs, ItemStack[] aOutputs, Object aSpecialItems, long[] aChances, FluidStack[] aFluidInputs, FluidStack[] aFluidOutputs, long aDuration, long aEUt, long aSpecialValue) {
		if (aInputs == null) aInputs = new ItemStack[0];
		if (aOutputs == null) aOutputs = new ItemStack[0];
		if (aFluidInputs == null) aFluidInputs = new FluidStack[0];
		if (aFluidOutputs == null) aFluidOutputs = new FluidStack[0];
		if (aChances == null) aChances = new long[aOutputs.length];
		if (aChances.length < aOutputs.length) aChances = Arrays.copyOf(aChances, aOutputs.length);
		
		aInputs			= UT.Code.getWithoutTrailingNulls(aInputs		).toArray(new ItemStack[0]);
		aOutputs		= UT.Code.getWithoutTrailingNulls(aOutputs		).toArray(new ItemStack[0]);
		aFluidInputs	= UT.Code.getWithoutNulls(aFluidInputs			).toArray(new FluidStack[0]);
		aFluidOutputs	= UT.Code.getWithoutNulls(aFluidOutputs			).toArray(new FluidStack[0]);
		
		OreDictManager.INSTANCE.setStackArray(T, aInputs);
		OreDictManager.INSTANCE.setStackArray(T, aOutputs);
		
		for (ItemStack tStack : aOutputs) UT.Stacks.update(tStack);
		
		for (int i = 0; i < aChances		.length; i++) if (aChances[i] <= 0) aChances[i] = 10000;
		for (int i = 0; i < aFluidInputs	.length; i++) aFluidInputs [i] = new FluidStackContainer(aFluidInputs [i]);
		for (int i = 0; i < aFluidOutputs	.length; i++) aFluidOutputs[i] = new FluidStackContainer(aFluidOutputs[i]);
		
		if (aOptimize)  {
			for (int i = 0; i < aInputs.length; i++) if (aInputs[i] != null && Items.feather.getDamage(aInputs[i]) != W) for (int j = 0; j < aOutputs.length; j++) {
				if (UT.Stacks.equal(aInputs[i], aOutputs[j])) {
					if (aInputs[i].stackSize >= aOutputs[j].stackSize) {
						aInputs[i].stackSize -= aOutputs[j].stackSize;
						aOutputs[j] = null;
					} else {
						aOutputs[j].stackSize -= aInputs[i].stackSize;
					}
				}
			}
			
			if (aDuration >= 32) {
				ArrayList<ItemStack> tList = new ArrayListNoNulls<ItemStack>(Arrays.asList(aInputs));
				tList.addAll(Arrays.asList(aOutputs));
				
				for (byte i = (byte)Math.min(64, aDuration / 16); i > 1; i--) if (aDuration / i >= 16) {
					boolean temp = T;
					for (int j = 0, k = tList.size(); temp &&  j < k; j++) if (tList.get(j).stackSize  % i != 0) temp = F;
					for (int j = 0; temp && j < aFluidInputs .length; j++) if (aFluidInputs [j].amount % i != 0) temp = F;
					for (int j = 0; temp && j < aFluidOutputs.length; j++) if (aFluidOutputs[j].amount % i != 0) temp = F;
					if (temp) {
						for (int j = 0, k = tList.size();  j < k; j++) tList.get(j).stackSize  /= i;
						for (int j = 0; j < aFluidInputs .length; j++) aFluidInputs [j].amount /= i;
						for (int j = 0; j < aFluidOutputs.length; j++) aFluidOutputs[j].amount /= i;
						aDuration /= i;
					}
				}
			}
		}
		
		mInputs = aInputs;
		mOutputs = aOutputs;
		mSpecialItems = aSpecialItems;
		mChances = aChances;
		Arrays.fill(mMaxChances = new long[aChances.length], 10000);
		mFluidInputs = aFluidInputs;
		mFluidOutputs = aFluidOutputs;
		mDuration = aDuration;
		mSpecialValue = aSpecialValue;
		mEUt = aEUt;
		
//		checkCellBalance();
	}
	
	// -----------------------------------------------------------------------------------------------------------------
	// Here are a few Classes I use for Special Cases in some Machines without having to write a separate Machine Class.
	// -----------------------------------------------------------------------------------------------------------------
	
	/**
	 * Abstract Class for general Recipe Handling of non GT Recipes
	 */
	public static abstract class RecipeMapNonGTRecipes extends RecipeMap {
		public RecipeMapNonGTRecipes(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return F;}
		@Override public boolean containsInput(FluidStack aFluid) {return F;}
		@Override public boolean containsInput(Fluid aFluid) {return F;}
		
		@Override public Recipe add(Recipe aRecipe) {return null;}
		@Override public void reInit() {/**/}
		@Override protected Recipe addToItemMap(Recipe aRecipe) {return null;}
	}
	
	/**
	 * Just a Recipe Map with Utility specifically for Fuels.
	 */
	public static class RecipeMapFuel extends RecipeMap {
		public RecipeMapFuel(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		public Recipe addFuel(ItemStack aInput, ItemStack aOutput, long aFuelValueInEU) {
			return addFuel(aInput, aOutput, null, null, 10000, aFuelValueInEU);
		}
		
		public Recipe addFuel(ItemStack aInput, ItemStack aOutput, long aChance, long aFuelValueInEU) {
			return addFuel(aInput, aOutput, null, null, aChance, aFuelValueInEU);
		}
		
		public Recipe addFuel(FluidStack aFluidInput, FluidStack aFluidOutput, long aFuelValueInEU) {
			return addFuel(null, null, aFluidInput, aFluidOutput, 10000, aFuelValueInEU);
		}
		
		public Recipe addFuel(ItemStack aInput, ItemStack aOutput, FluidStack aFluidInput, FluidStack aFluidOutput, long aFuelValueInEU) {
			return addFuel(aInput, aOutput, aFluidInput, aFluidOutput, 10000, aFuelValueInEU);
		}
		
		public Recipe addFuel(ItemStack aInput, ItemStack aOutput, FluidStack aFluidInput, FluidStack aFluidOutput, long aChance, long aFuelValueInEU) {
			return addRecipe(T, new ItemStack[] {aInput}, new ItemStack[] {aOutput}, null, new long[] {aChance}, new FluidStack[] {aFluidInput}, new FluidStack[] {aFluidOutput}, 0, 0, aFuelValueInEU);
		}
	}
	
	/**
	 * Special Class for Furnace Recipe handling.
	 */
	public static class RecipeMapFurnace extends RecipeMapNonGTRecipes {
		public RecipeMapFurnace(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null) return null;
			if (aRecipe != null && aRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return aRecipe;
			ItemStack tOutput = GT_ModHandler.getSmeltingOutput(aInputs[0], F, null);
			return tOutput == null ? null : new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(1, aInputs[0])}, new ItemStack[] {tOutput}, null, null, null, null, EU_PER_SMELT / 200 + (EU_PER_SMELT % 200 == 0 ? 0 : 1), 16, 0);
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return GT_ModHandler.getSmeltingOutput(aStack, F, null) != null;}
	}
	
	/**
	 * Special Class for Microwave Recipe handling.
	 */
	public static class RecipeMapMicrowave extends RecipeMapNonGTRecipes {
		public RecipeMapMicrowave(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null) return null;
			if (aRecipe != null && aRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return aRecipe;
			ItemStack tOutput = GT_ModHandler.getSmeltingOutput(aInputs[0], F, null);
			
			if (UT.Stacks.equal(aInputs[0], new ItemStack(Items.book, 1, W))) {
				return new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(1, aInputs[0])}, new ItemStack[] {UT.Books.getBookWithTitle("Manual_Microwave")}, null, null, null, null, 32, 4, 0);
			}
			
			// Check Container Item of Input since it is around the Input, then the Input itself, then Container Item of Output and last check the Output itself
			for (ItemStack tStack : new ItemStack[] {UT.Stacks.container(aInputs[0], T), aInputs[0], UT.Stacks.container(tOutput, T), tOutput}) if (tStack != null) {
				if (UT.Stacks.equal(tStack, new ItemStack(Blocks.netherrack, 1, W), T)
				 || UT.Stacks.equal(tStack, new ItemStack(Blocks.tnt, 1, W), T)
				 || UT.Stacks.equal(tStack, new ItemStack(Items.egg, 1, W), T)
				 || UT.Stacks.equal(tStack, new ItemStack(Items.firework_charge, 1, W), T)
				 || UT.Stacks.equal(tStack, new ItemStack(Items.fireworks, 1, W), T)
				 || UT.Stacks.equal(tStack, new ItemStack(Items.fire_charge, 1, W), T)
				) {
					if (aTileEntity instanceof IGregTechTileEntity) ((IGregTechTileEntity)aTileEntity).doExplosion(aSize * 4);
					return null;
				}
				OreDictItemData tData = OM.anydata(tStack);
				
				
				
				if (tData != null) {
					if (tData.mMaterial != null && tData.mMaterial.mMaterial != null) {
						if (tData.mMaterial.mMaterial.contains(TD.Atomic.METAL) || tData.mMaterial.mMaterial.contains(TD.Properties.EXPLOSIVE)) {
							if (aTileEntity instanceof IGregTechTileEntity) ((IGregTechTileEntity)aTileEntity).doExplosion(aSize * 4);
							return null;
						}
						if (tData.mMaterial.mMaterial.contains(TD.Properties.FLAMMABLE)) {
							if (aTileEntity instanceof IGregTechTileEntity) ((IGregTechTileEntity)aTileEntity).setOnFire();
							return null;
						}
					}
					for (OreDictMaterialStack tMaterial : tData.mByProducts) if (tMaterial != null) {
						if (tMaterial.mMaterial.contains(TD.Atomic.METAL) || tMaterial.mMaterial.contains(TD.Properties.EXPLOSIVE)) {
							if (aTileEntity instanceof IGregTechTileEntity) ((IGregTechTileEntity)aTileEntity).doExplosion(aSize * 4);
							return null;
						}
						if (tMaterial.mMaterial.contains(TD.Properties.FLAMMABLE)) {
							if (aTileEntity instanceof IGregTechTileEntity) ((IGregTechTileEntity)aTileEntity).setOnFire();
							return null;
						}
					}
				}
				if (TileEntityFurnace.getItemBurnTime(tStack) > 0) {
					if (aTileEntity instanceof IGregTechTileEntity) ((IGregTechTileEntity)aTileEntity).setOnFire();
					return null;
				}
				
			}
			
			return tOutput == null ? null : new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(1, aInputs[0])}, new ItemStack[] {tOutput}, null, null, null, null, 32, 4, 0);
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return GT_ModHandler.getSmeltingOutput(aStack, F, null) != null;}
	}
	
	/**
	 * Special Class for Unboxinator handling.
	 */
	public static class RecipeMapUnboxinator extends RecipeMap {
		public RecipeMapUnboxinator(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			if (aInputs == null || aInputs.length <= 0 || !IL.IC2_Scrapbox.equal(aInputs[0], F, T)) return super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
			ItemStack tOutput = GT_ModHandler.getRandomScrapboxDrop();
			if (tOutput == null) return super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
			Recipe rRecipe = new Recipe(F, new ItemStack[] {IL.IC2_Scrapbox.get(1)}, new ItemStack[] {tOutput}, null, null, null, null, 16, 1, 0);
			// It is not allowed to be buffered due to the random Output
			rRecipe.mCanBeBuffered = F;
			// Due to its randomness it is not good if there are Items in the Output Slot, because those Items could manipulate the outcome.
			rRecipe.mNeedsEmptyOutput = T;
			return rRecipe;
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return IL.IC2_Scrapbox.equal(aStack, F, T) || super.containsInput(aStack);}
	}
	
	/**
	 * Special Class for Fluid Canner handling.
	 */
	public static class RecipeMapFluidCanner extends RecipeMap {
		public RecipeMapFluidCanner(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			Recipe rRecipe = super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
			if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null || rRecipe != null || !GT_API.sAPIPhaseFinishedServerStarted) return rRecipe;
			if (aFluids != null && aFluids.length >  0 && aFluids[0] != null) {
				ItemStack tOutput = UT.Fluids.fillFluidContainer(aFluids[0], aInputs[0], F, T);
				FluidStack tFluid = UT.Fluids.getFluidForFilledItem(tOutput, T);
				if (tFluid != null) rRecipe = new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(1, aInputs[0])}, new ItemStack[] {tOutput}, null, null, new FluidStack[] {tFluid}, null, Math.max(tFluid.amount / 64, 16), 1, 0);
			}
			if (rRecipe == null) {
				FluidStack tFluid = UT.Fluids.getFluidForFilledItem(aInputs[0], T);
				if (tFluid != null) rRecipe = new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(1, aInputs[0])}, new ItemStack[] {UT.Stacks.container(aInputs[0], T)}, null, null, null, new FluidStack[] {tFluid}, Math.max(tFluid.amount / 64, 16), 1, 0);
			}
			if (rRecipe != null) rRecipe.mCanBeBuffered = F;
			return rRecipe;
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return aStack != null && (super.containsInput(aStack) || (aStack.getItem() instanceof IFluidContainerItem && ((IFluidContainerItem)aStack.getItem()).getCapacity(aStack) > 0));}
		@Override public boolean containsInput(FluidStack aFluid) {return T;}
		@Override public boolean containsInput(Fluid aFluid) {return T;}
	}
	
	/**
	 * Special Class for Recycler Recipe handling.
	 */
	public static class RecipeMapRecycler extends RecipeMapNonGTRecipes {
		public RecipeMapRecycler(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null) return null;
			if (aRecipe != null && aRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return aRecipe;
		    return new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(1, aInputs[0])}, GT_ModHandler.getRecyclerOutput(UT.Stacks.copyAmount(64, aInputs[0]), 0) == null ? null : new ItemStack[] {IL.IC2_Scrap.get(1)}, null, new long[] {1250}, null, null, 45, 1, 0);
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return GT_ModHandler.getRecyclerOutput(UT.Stacks.copyAmount(64, aStack), 0) != null;}
	}
	
	/**
	 * Special Class for Compressor Recipe handling.
	 */
	public static class RecipeMapCompressor extends RecipeMapNonGTRecipes {
		public RecipeMapCompressor(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null) return null;
			if (aRecipe != null && aRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return aRecipe;
			ItemStack tComparedInput = UT.Stacks.copy(aInputs[0]);
			ItemStack[] tOutputItems = GT_ModHandler.getMachineOutput(tComparedInput, ic2.api.recipe.Recipes.compressor.getRecipes(), T, new NBTTagCompound(), null, null, null);
		    return UT.Code.containsSomething(tOutputItems) ? new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(aInputs[0].stackSize - tComparedInput.stackSize, aInputs[0])}, tOutputItems, null, null, null, null, 400, 2, 0) : null;
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return UT.Code.containsSomething(GT_ModHandler.getMachineOutput(UT.Stacks.copyAmount(64, aStack), ic2.api.recipe.Recipes.compressor.getRecipes(), F, new NBTTagCompound(), null, null, null));}
	}
	
	/**
	 * Special Class for Extractor Recipe handling.
	 */
	public static class RecipeMapExtractor extends RecipeMapNonGTRecipes {
		public RecipeMapExtractor(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null) return null;
			if (aRecipe != null && aRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return aRecipe;
			ItemStack tComparedInput = UT.Stacks.copy(aInputs[0]);
			ItemStack[] tOutputItems = GT_ModHandler.getMachineOutput(tComparedInput, ic2.api.recipe.Recipes.extractor.getRecipes(), T, new NBTTagCompound(), null, null, null);
		    return UT.Code.containsSomething(tOutputItems) ? new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(aInputs[0].stackSize - tComparedInput.stackSize, aInputs[0])}, tOutputItems, null, null, null, null, 400, 2, 0) : null;
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return UT.Code.containsSomething(GT_ModHandler.getMachineOutput(UT.Stacks.copyAmount(64, aStack), ic2.api.recipe.Recipes.extractor.getRecipes(), F, new NBTTagCompound(), null, null, null));}
	}
	
	/**
	 * Special Class for Thermal Centrifuge Recipe handling.
	 */
	public static class RecipeMapThermalCentrifuge extends RecipeMapNonGTRecipes {
		public RecipeMapThermalCentrifuge(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null) return null;
			if (aRecipe != null && aRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return aRecipe;
			ItemStack tComparedInput = UT.Stacks.copy(aInputs[0]);
			ItemStack[] tOutputItems = GT_ModHandler.getMachineOutput(tComparedInput, ic2.api.recipe.Recipes.centrifuge.getRecipes(), T, new NBTTagCompound(), null, null, null);
		    return UT.Code.containsSomething(tOutputItems) ? new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(aInputs[0].stackSize - tComparedInput.stackSize, aInputs[0])}, tOutputItems, null, null, null, null, 400, 48, 0) : null;
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return UT.Code.containsSomething(GT_ModHandler.getMachineOutput(UT.Stacks.copyAmount(64, aStack), ic2.api.recipe.Recipes.centrifuge.getRecipes(), F, new NBTTagCompound(), null, null, null));}
	}
	
	/**
	 * Special Class for Ore Washer Recipe handling.
	 */
	public static class RecipeMapOreWasher extends RecipeMapNonGTRecipes {
		public RecipeMapOreWasher(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null || aFluids == null || aFluids.length < 1 || !GT_ModHandler.isWater(aFluids[0])) return null;
			if (aRecipe != null && aRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return aRecipe;
			ItemStack tComparedInput = UT.Stacks.copy(aInputs[0]);
			NBTTagCompound aRecipeMetaData = new NBTTagCompound();
			ItemStack[] tOutputItems = GT_ModHandler.getMachineOutput(tComparedInput, ic2.api.recipe.Recipes.oreWashing.getRecipes(), T, aRecipeMetaData, null, null, null);
			return UT.Code.containsSomething(tOutputItems) ? new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(aInputs[0].stackSize - tComparedInput.stackSize, aInputs[0])}, tOutputItems, null, null, new FluidStack[] {new FluidStack(aFluids[0].getFluid(), ((NBTTagCompound)aRecipeMetaData.getTag("return")).getInteger("amount"))}, null, 400, 16, 0) : null;
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return UT.Code.containsSomething(GT_ModHandler.getMachineOutput(UT.Stacks.copyAmount(64, aStack), ic2.api.recipe.Recipes.oreWashing.getRecipes(), F, new NBTTagCompound(), null, null, null));}
		@Override public boolean containsInput(FluidStack aFluid) {return GT_ModHandler.isWater(aFluid);}
		@Override public boolean containsInput(Fluid aFluid) {return GT_ModHandler.isWater(new FluidStack(aFluid, 0));}
	}
	
	/**
	 * Special Class for Macerator/RockCrusher Recipe handling.
	 */
	public static class RecipeMapMacerator extends RecipeMap {
		public RecipeMapMacerator(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null || !GT_API.sAPIPhaseFinishedServerStarted) return super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
		    aRecipe = super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
		    if (aRecipe != null) return aRecipe;
		    
		    try {
		    	List<ItemStack> tRecipeOutputs = mods.railcraft.api.crafting.RailcraftCraftingManager.rockCrusher.getRecipe(UT.Stacks.copyAmount(1, aInputs[0])).getRandomizedOuputs();
		    	if (tRecipeOutputs != null) {
		    		aRecipe = new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(1, aInputs[0])}, tRecipeOutputs.toArray(new ItemStack[tRecipeOutputs.size()]), null, null, null, null, 800, 2, 0);
		    		aRecipe.mCanBeBuffered = F;
		    		aRecipe.mNeedsEmptyOutput = T;
		    		return aRecipe;
		    	}
		    } catch(NoClassDefFoundError e) {if (D1) GT_Log.err.println("Railcraft Not loaded");} catch(NullPointerException e) {/**/}
		    
			ItemStack tComparedInput = UT.Stacks.copy(aInputs[0]);
			ItemStack[] tOutputItems = GT_ModHandler.getMachineOutput(tComparedInput, ic2.api.recipe.Recipes.macerator.getRecipes(), T, new NBTTagCompound(), null, null, null);
			return UT.Code.containsSomething(tOutputItems) ? new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(aInputs[0].stackSize - tComparedInput.stackSize, aInputs[0])}, tOutputItems, null, null, null, null, 400, 2, 0) : null;
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return super.containsInput(aStack) || UT.Code.containsSomething(GT_ModHandler.getMachineOutput(UT.Stacks.copyAmount(64, aStack), ic2.api.recipe.Recipes.macerator.getRecipes(), F, new NBTTagCompound(), null, null, null));}
	}
	
	/**
	 * Special Class for Assembler handling.
	 */
	public static class RecipeMapAssembler extends RecipeMap {
		public RecipeMapAssembler(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			Recipe rRecipe = super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
			if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null || rRecipe == null || !GT_API.sAPIPhaseFinishedServerStarted) return rRecipe;
			for (ItemStack aInput : aInputs) {
				if (IL.Paper_Printed_Pages.equal(aInput, F, T)) {
					rRecipe = rRecipe.copy();
					rRecipe.mCanBeBuffered = F;
					rRecipe.mOutputs[0].setTagCompound(aInput.getTagCompound());
				}
			}
			return rRecipe;
		}
	}
	
	/**
	 * Special Class for Furnace Fuels. Also does not accept Lava Containers.
	 */
	public static class RecipeMapFurnaceFuel extends RecipeMap {
		public RecipeMapFurnaceFuel(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal + " (1 Smelt = 5000 Units)", aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			Recipe rRecipe = super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
			if (aInputs == null || aInputs.length < 1 || aInputs[0] == null || !GT_API.sAPIPhaseFinishedServerStarted) return rRecipe;
			if (rRecipe == null) {
				long tFuelValue = GT_ModHandler.getFuelValue(aInputs[0]);
				if (tFuelValue > 0 && !UT.Fluids.containsFluid(aInputs[0], Fluids.lava(0), T)) {
					ItemStack tContainer = UT.Stacks.container(aInputs[0], T);
					if (tContainer == null) {
						OreDictItemData tData = OM.anydata(aInputs[0]);
						OreDictMaterialStack tMaterial = null;
						if (tData != null) {
							for (OreDictMaterialStack aMaterial : tData.getAllMaterialStacks()) {
								if (tMaterial == null || tMaterial.mAmount <= 0)
									tMaterial = OM.stack(aMaterial.mMaterial.mTargetBurning.mMaterial, UT.Code.units(aMaterial.mAmount, U, aMaterial.mMaterial.mTargetBurning.mAmount, false));
								else if (tMaterial.mMaterial == aMaterial.mMaterial.mTargetBurning.mMaterial)
									tMaterial.mAmount += UT.Code.units(aMaterial.mAmount, U, aMaterial.mMaterial.mTargetBurning.mAmount, false);
							}
						}
						rRecipe = new Recipe(T, new ItemStack[] {UT.Stacks.copyAmount(1, aInputs[0])}, new ItemStack[] {OM.dust(tMaterial)}, null, null, null, null, 1, (tFuelValue * EU_PER_SMELT) / TICKS_PER_SMELT, 0);
					} else {
						rRecipe = new Recipe(T, new ItemStack[] {UT.Stacks.copyAmount(1, aInputs[0])}, new ItemStack[] {tContainer}, null, null, null, null, 1, (tFuelValue * EU_PER_SMELT) / TICKS_PER_SMELT, 0);
					}
					rRecipe.mCanBeBuffered = (aInputs[0].getTagCompound() == null);
					if (rRecipe.mCanBeBuffered) addRecipe(rRecipe, F, F, T);
				}
			}
			return rRecipe;
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return null != findRecipe(null, null, T, Long.MAX_VALUE, null, ZL_FLUIDSTACK, aStack);}
	}
	
	/**
	 * Special Class for Chiseling.
	 */
	public static class RecipeMapChisel extends RecipeMap {
		public RecipeMapChisel(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			Recipe rRecipe = super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
			if (aInputs == null || aInputs.length < 1 || aInputs[0] == null || !GT_API.sAPIPhaseFinishedServerStarted) return rRecipe;
			if (rRecipe == null) {
				OreDictItemData tData = OM.anyassociation(aInputs[0]);
				if (tData != null && (tData.mPrefix == OP.blockDust || tData.mPrefix == OP.blockIngot || tData.mPrefix == OP.blockGem || tData.mPrefix == OP.blockPlate || tData.mPrefix == OP.blockSolid)) {
					List<ItemStack> tList = OreDictManager.getOres(tData.toString(), true);
					int tSize = tList.size();
					if (tSize > 0) {
						ItemStack tOutput = UT.Stacks.copyAmount(1, tList.get(0));
						tSize--;
						for (int i = 0; i < tSize; i++) if (UT.Stacks.equal(aInputs[0], tList.get(i))) {tOutput = UT.Stacks.copyAmount(1, tList.get(i+1)); break;}
						rRecipe = new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(1, aInputs[0])}, new ItemStack[] {tOutput}, null, null, null, null, 96, 12, 0);
						rRecipe.mCanBeBuffered = T;
						return rRecipe;
					}
				}
			}
			return rRecipe;
		}
	}
	
	/**
	 * Special Class for Forming Press handling.
	 */
	public static class RecipeMapFormingPress extends RecipeMap {
		public RecipeMapFormingPress(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			Recipe rRecipe = super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
			if (aInputs == null || aInputs.length < 2 || aInputs[0] == null || aInputs[1] == null || !GT_API.sAPIPhaseFinishedServerStarted) return rRecipe;
			if (rRecipe == null) {
				if (IL.Shape_Mold_Name.equal(aInputs[0], F, T)) {
					ItemStack tOutput = UT.Stacks.copyAmount(1, aInputs[1]);
					tOutput.setStackDisplayName(aInputs[0].getDisplayName());
					rRecipe = new Recipe(F, new ItemStack[] {IL.Shape_Mold_Name.get(0), UT.Stacks.copyAmount(1, aInputs[1])}, new ItemStack[] {tOutput}, null, null, null, null, 128, 8, 0);
					rRecipe.mCanBeBuffered = F;
					return rRecipe;
				}
				if (IL.Shape_Mold_Name.equal(aInputs[1], F, T)) {
					ItemStack tOutput = UT.Stacks.copyAmount(1, aInputs[0]);
					tOutput.setStackDisplayName(aInputs[1].getDisplayName());
					rRecipe = new Recipe(F, new ItemStack[] {IL.Shape_Mold_Name.get(0), UT.Stacks.copyAmount(1, aInputs[0])}, new ItemStack[] {tOutput}, null, null, null, null, 128, 8, 0);
					rRecipe.mCanBeBuffered = F;
					return rRecipe;
				}
				return null;
			}
			for (ItemStack aMold : aInputs) {
				if (IL.Shape_Mold_Credit.equal(aMold, F, T)) {
					NBTTagCompound tNBT = aMold.getTagCompound();
					if (tNBT == null) tNBT = new NBTTagCompound();
					if (!tNBT.hasKey("credit_security_id")) UT.NBT.setNumber(tNBT, "credit_security_id", System.nanoTime());
					aMold.setTagCompound(tNBT);
					
					rRecipe = rRecipe.copy();
					rRecipe.mCanBeBuffered = F;
					rRecipe.mOutputs[0].setTagCompound(tNBT);
					return rRecipe;
				}
			}
			return rRecipe;
		}
	}
	
	/**
	 * Special Class for Printer handling.
	 */
	public static class RecipeMapPrinter extends RecipeMap {
		public RecipeMapPrinter(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			Recipe rRecipe = super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
			if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null || aFluids == null || aFluids.length <= 0 || aFluids[0] == null || !GT_API.sAPIPhaseFinishedServerStarted) return rRecipe;
			
			Dyes aDye = null; for (Dyes tDye : Dyes.VALUES) if (tDye.isFluidDye(aFluids[0])) {aDye = tDye; break;}
			
			if (aDye == null) return rRecipe;
			
			if (rRecipe == null) {
				ItemStack
				tOutput = GT_ModHandler.getAllRecipeOutput(aTileEntity==null?null:aTileEntity.getWorld(), aInputs[0], aInputs[0], aInputs[0], aInputs[0], IL.DYE_ONLY_ITEMS[aDye.mIndex].get(1), aInputs[0], aInputs[0], aInputs[0], aInputs[0]);
				if (tOutput != null) return addRecipe(new Recipe(T, new ItemStack[] {UT.Stacks.copyAmount(8, aInputs[0])}, new ItemStack[] {tOutput}, null, null, new FluidStack[] {new FluidStack(aFluids[0].getFluid(), (int)L)}, null, 256, 2, 0), F, F, T);
				
				tOutput = GT_ModHandler.getAllRecipeOutput(aTileEntity==null?null:aTileEntity.getWorld(), aInputs[0], IL.DYE_ONLY_ITEMS[aDye.mIndex].get(1));
				if (tOutput != null) return addRecipe(new Recipe(T, new ItemStack[] {UT.Stacks.copyAmount(1, aInputs[0])}, new ItemStack[] {tOutput}, null, null, new FluidStack[] {new FluidStack(aFluids[0].getFluid(), (int)L)}, null,  32, 2, 0), F, F, T);
			} else {
				if (aInputs[0].getItem() == Items.paper) {
					if (!IL.Tool_DataStick.equal(aSpecialSlot, F, T)) return null;
					NBTTagCompound tNBT = aSpecialSlot.getTagCompound();
					if (tNBT == null || UT.Code.stringInvalid(tNBT.getString("title")) || UT.Code.stringInvalid(tNBT.getString("author"))) return null;
					
					rRecipe = rRecipe.copy();
					rRecipe.mCanBeBuffered = F;
					rRecipe.mOutputs[0].setTagCompound(tNBT);
					return rRecipe;
				}
				if (aInputs[0].getItem() == Items.map) {
					if (!IL.Tool_DataStick.equal(aSpecialSlot, F, T)) return null;
					NBTTagCompound tNBT = aSpecialSlot.getTagCompound();
					if (tNBT == null || !tNBT.hasKey("map_id")) return null;
					
					rRecipe = rRecipe.copy();
					rRecipe.mCanBeBuffered = F;
					rRecipe.mOutputs[0].setItemDamage(tNBT.getShort("map_id"));
					return rRecipe;
				}
				if (IL.Paper_Punch_Card_Empty.equal(aInputs[0], F, T)) {
					if (!IL.Tool_DataStick.equal(aSpecialSlot, F, T)) return null;
					NBTTagCompound tNBT = aSpecialSlot.getTagCompound();
					if (tNBT == null || !tNBT.hasKey("GT.PunchCardData")) return null;
					
					rRecipe = rRecipe.copy();
					rRecipe.mCanBeBuffered = F;
					rRecipe.mOutputs[0].setTagCompound(UT.NBT.getNBTString(new NBTTagCompound(), "GT.PunchCardData", tNBT.getString("GT.PunchCardData")));
					return rRecipe;
				}
			}
			return rRecipe;
		}
		
		@Override public boolean containsInput(ItemStack aStack) {return T;}
		@Override public boolean containsInput(FluidStack aFluid) {return super.containsInput(aFluid) || Dyes.isAnyFluidDye(aFluid);}
		@Override public boolean containsInput(Fluid aFluid) {return super.containsInput(aFluid) || Dyes.isAnyFluidDye(aFluid);}
	}
	
	/**
	 * Special Abstract Class for dynamic Recipe handling.
	 */
	public static abstract class RecipeMapSpecialSingleInput extends RecipeMap {
		public RecipeMapSpecialSingleInput(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		@Override
		public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
			Recipe rRecipe = super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
			if (rRecipe != null || aInputs == null || aInputs.length <= 0 || aInputs[0] == null || !GT_API.sAPIPhaseFinishedServerStarted) return rRecipe;
			return getRecipeFor(aInputs[0]);
		}
		
		@Override
		public boolean containsInput(ItemStack aStack) {
			return super.containsInput(aStack) || getRecipeFor(aStack) != null;
		}
		
		@Override
		public List<Recipe> getNEIUsages(ItemStack... aInputs) {
			List<Recipe> rList = super.getNEIUsages(aInputs);
			for (ItemStack aInput : aInputs) if (rList.add(getRecipeFor(aInput))) break;
			return rList;
		}
		
		protected abstract Recipe getRecipeFor(ItemStack aInput);
	}
	
	/**
	 * Special Class for Shredder Recipe handling, because Recycling.
	 */
	public static class RecipeMapShredder extends RecipeMapSpecialSingleInput {
		public RecipeMapShredder(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		private List<Recipe> mBufferedDynamicRecipes = null;
		
		@Override
		public List<Recipe> getNEIAllRecipes() {
			List<Recipe> rList = super.getNEIAllRecipes();
			if (mBufferedDynamicRecipes == null) {
				mBufferedDynamicRecipes = new ArrayListNoNulls<Recipe>();
				for (OreDictMaterial tMaterial : OP.dust.mRegisteredMaterials) {
					for (ItemStackContainer tStack : tMaterial.mRegisteredItems) {
						mBufferedDynamicRecipes.add(getRecipeFor(tStack.toStack()));
					}
				}
			}
			rList.addAll(mBufferedDynamicRecipes);
			return rList;
		}
		
		@Override
		public List<Recipe> getNEIRecipes(ItemStack... aOutputs) {
			List<Recipe> rList = super.getNEIRecipes(aOutputs);
			for (ItemStack aOutput : aOutputs) {
				OreDictItemData aData = OM.anyassociation(aOutput);
				if (aData != null && aData.mPrefix.contains(TD.Prefix.DUST_BASED)) {
					for (ItemStackContainer tStack : aData.mMaterial.mMaterial.mRegisteredItems) {
						rList.add(getRecipeFor(tStack.toStack()));
					}
					break;
				}
			}
			return rList;
		}
		
		@Override
		protected Recipe getRecipeFor(ItemStack aInput) {
			OreDictItemData aData = OM.anydata(aInput);
			if (aData == null || (aData.mMaterial != null && aData.mMaterial.mMaterial.contains(TD.Atomic.ANTIMATTER)) || (aData.mPrefix != null && (aData.mPrefix.contains(TD.Prefix.DUST_BASED) || aData.mPrefix.contains(TD.Prefix.ORE) || !aData.mPrefix.contains(TD.Prefix.RECYCLABLE)))) return null;
			List<OreDictMaterialStack> tList = new ArrayListNoNulls<OreDictMaterialStack>();
			for (OreDictMaterialStack tMaterial : aData.getAllMaterialStacks()) if (tMaterial.mMaterial.mTargetPulver.mAmount > 0) OM.stack(UT.Code.units(tMaterial.mAmount, U, tMaterial.mMaterial.mTargetPulver.mAmount, F), tMaterial.mMaterial.mTargetPulver.mMaterial).addToList(tList);
			if (tList.isEmpty()) return null;
			ItemStack[] tOutputs = new ItemStack[Math.min(tList.size(), mOutputItemsCount)];
			int i = 0, tDuration = 0;
			for (OreDictMaterialStack tMaterial : tList) {
				tDuration += UT.Code.units(tMaterial.mAmount, U, 100*Math.max(1, tMaterial.mMaterial.mToolQuality+1), T);
				if (i < tOutputs.length) {
					ItemStack tStack = OM.dust(tMaterial);
					if (tStack != null) tOutputs[i++] = tStack;
				}
			}
			if (!UT.Code.exists(0, tOutputs)) return null;
			Recipe rRecipe = new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(1, aInput)}, tOutputs, null, null, ZL_FLUIDSTACK, ZL_FLUIDSTACK, Math.max(1, tDuration), 16, 0);
			rRecipe.mCanBeBuffered = F;
			return rRecipe;
		}
	}
	
	/**
	 * Special Class for Crusher Recipe handling, because there are just way too many Ores.
	 */
	public static class RecipeMapCrusher extends RecipeMapSpecialSingleInput {
		public RecipeMapCrusher(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		private List<Recipe> mBufferedDynamicRecipes = null;
		
		@Override
		public List<Recipe> getNEIAllRecipes() {
			List<Recipe> rList = super.getNEIAllRecipes();
			if (mBufferedDynamicRecipes == null) {
				mBufferedDynamicRecipes = new ArrayListNoNulls<Recipe>();
				for (OreDictMaterial tMaterial : OP.crushed.mRegisteredMaterials) {
					for (ItemStackContainer tStack : tMaterial.mRegisteredItems) {
						mBufferedDynamicRecipes.add(getRecipeFor(tStack.toStack()));
					}
				}
			}
			rList.addAll(mBufferedDynamicRecipes);
			return rList;
		}
		
		@Override
		public List<Recipe> getNEIRecipes(ItemStack... aOutputs) {
			List<Recipe> rList = super.getNEIRecipes(aOutputs);
			for (ItemStack aOutput : aOutputs) {
				OreDictItemData aData = OM.anyassociation(aOutput);
				if (aData != null && aData.mPrefix == OP.crushed) {
					for (ItemStackContainer tStack : aData.mMaterial.mMaterial.mRegisteredItems) {
						rList.add(getRecipeFor(tStack.toStack()));
					}
					break;
				}
			}
			return rList;
		}
		
		@Override
		protected Recipe getRecipeFor(ItemStack aInput) {
			OreDictItemData aData = OM.anydata(aInput);
			if (aData == null || (aData.mMaterial != null && aData.mMaterial.mMaterial.contains(TD.Atomic.ANTIMATTER)) || (aData.mPrefix == null || !aData.mPrefix.contains(TD.Prefix.ORE) || aData.mPrefix.contains(TD.Prefix.DUST_ORE))) return null;
			if (aData.mPrefix == orePoor || aData.mPrefix == oreSmall || aData.mPrefix == oreRich || aData.mPrefix == oreNormal) {
				// TODO
				return null;
			}
			ItemStack[] tOutputs = new ItemStack[Math.max(1, mOutputItemsCount)];
			tOutputs[0] = OM.get(OP.crushed, aData.mMaterial.mMaterial.mTargetCrushing.mMaterial, UT.Code.units(aData.mMaterial.mMaterial.mTargetCrushing.mAmount, U, 2 * aData.mMaterial.mMaterial.mOreMultiplier * Math.max(1, ConfigsGT.OREPROCESSING.get(ConfigCategories.Materials.oreprocessingoutputmultiplier, aData.mMaterial.toString(), 1L)) * (aData.mPrefix == OP.oreNether || aData.mPrefix == OP.oreDense || aData.mPrefix == OP.oreEnd ? 2 : 1), F));
			if (tOutputs[0] == null) return null;
			int i = 0, tDuration = 200*tOutputs[0].stackSize*Math.max(1, aData.mMaterial.mMaterial.mToolQuality+1);
			for (OreDictMaterialStack tMaterial : aData.mPrefix.mByProducts) {
				tDuration += UT.Code.units(tMaterial.mAmount, U, 200*Math.max(1, tMaterial.mMaterial.mToolQuality+1), T);
				if (i < tOutputs.length - 1) {
					ItemStack tStack = OM.dust(tMaterial.mMaterial.mTargetCrushing.mMaterial, UT.Code.units(tMaterial.mAmount, U, tMaterial.mMaterial.mTargetCrushing.mAmount, F));
					if (tStack != null) tOutputs[++i] = tStack;
				}
			}
			Recipe rRecipe = new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(1, aInput)}, tOutputs, null, null, ZL_FLUIDSTACK, ZL_FLUIDSTACK, Math.max(1, tDuration), 16, 0);
			rRecipe.mCanBeBuffered = F;
			return rRecipe;
		}
	}
	
	/**
	 * Special Class for Hammer Recipe handling, because there are just way too many Ores.
	 */
	public static class RecipeMapHammer extends RecipeMapSpecialSingleInput {
		public RecipeMapHammer(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed) {
			super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed);
		}
		
		private List<Recipe> mBufferedDynamicRecipes = null;
		
		@Override
		public List<Recipe> getNEIAllRecipes() {
			List<Recipe> rList = super.getNEIAllRecipes();
			if (mBufferedDynamicRecipes == null) {
				mBufferedDynamicRecipes = new ArrayListNoNulls<Recipe>();
				for (OreDictMaterial tMaterial : OP.crushed.mRegisteredMaterials) {
					for (ItemStackContainer tStack : tMaterial.mRegisteredItems) {
						mBufferedDynamicRecipes.add(getRecipeFor(tStack.toStack()));
					}
				}
			}
			rList.addAll(mBufferedDynamicRecipes);
			return rList;
		}
		
		@Override
		public List<Recipe> getNEIRecipes(ItemStack... aOutputs) {
			List<Recipe> rList = super.getNEIRecipes(aOutputs);
			for (ItemStack aOutput : aOutputs) {
				OreDictItemData aData = OM.anyassociation(aOutput);
				if (aData != null && aData.mPrefix == OP.crushed) {
					for (ItemStackContainer tStack : aData.mMaterial.mMaterial.mRegisteredItems) {
						rList.add(getRecipeFor(tStack.toStack()));
					}
					break;
				}
			}
			return rList;
		}
		
		@Override
		protected Recipe getRecipeFor(ItemStack aInput) {
			OreDictItemData aData = OM.anydata(aInput);
			if (aData == null || (aData.mMaterial != null && aData.mMaterial.mMaterial.contains(TD.Atomic.ANTIMATTER)) || (aData.mPrefix == null || !aData.mPrefix.contains(TD.Prefix.ORE) || aData.mPrefix.contains(TD.Prefix.DUST_ORE))) return null;
			if (aData.mPrefix == orePoor || aData.mPrefix == oreSmall || aData.mPrefix == oreRich || aData.mPrefix == oreNormal) {
				// TODO
				return null;
			}
			ItemStack[] tOutputs = new ItemStack[Math.max(1, mOutputItemsCount)];
			tOutputs[0] = OM.get(OP.gem, aData.mMaterial.mMaterial, OM.get(OP.crushed, aData.mMaterial.mMaterial.mTargetCrushing.mMaterial, UT.Code.units(aData.mMaterial.mMaterial.mTargetCrushing.mAmount, U, aData.mMaterial.mMaterial.mOreMultiplier * Math.max(1, ConfigsGT.OREPROCESSING.get(ConfigCategories.Materials.oreprocessingoutputmultiplier, aData.mMaterial.toString(), 1L)) * (aData.mPrefix == OP.oreNether || aData.mPrefix == OP.oreDense || aData.mPrefix == OP.oreEnd ? 2 : 1), F)), aData.mMaterial.mMaterial.mOreMultiplier * Math.max(1, ConfigsGT.OREPROCESSING.get(ConfigCategories.Materials.oreprocessingoutputmultiplier, aData.mMaterial.toString(), 1L)) * (aData.mPrefix == OP.oreNether || aData.mPrefix == OP.oreDense || aData.mPrefix == OP.oreEnd ? 2 : 1));
			if (tOutputs[0] == null) return null;
			int i = 0, tDuration = 16*tOutputs[0].stackSize*Math.max(1, aData.mMaterial.mMaterial.mToolQuality+1);
			for (OreDictMaterialStack tMaterial : aData.mPrefix.mByProducts) {
				tDuration += UT.Code.units(tMaterial.mAmount, U, 200*Math.max(1, tMaterial.mMaterial.mToolQuality+1), T);
				if (i < tOutputs.length - 1) {
					ItemStack tStack = OM.dust(tMaterial.mMaterial.mTargetCrushing.mMaterial, UT.Code.units(tMaterial.mAmount, U, tMaterial.mMaterial.mTargetCrushing.mAmount, F));
					if (tStack != null) tOutputs[++i] = tStack;
				}
			}
			Recipe rRecipe = new Recipe(F, new ItemStack[] {UT.Stacks.copyAmount(1, aInput)}, tOutputs, null, null, ZL_FLUIDSTACK, ZL_FLUIDSTACK, Math.max(1, tDuration), 16, 0);
			rRecipe.mCanBeBuffered = F;
			return rRecipe;
		}
	}
}